/* climus.c
 * Cliente de pruebas para el programa servidor de partidas de mus "sumus.c"
 * Autor: Antonio Garcia
 *        (angarcia@openbank.es)
 *  Copyright (C) 2000  Antonio Garcia
 *
 *  Este programa es Software Libre. Puedes usarlo, redistribuirlo o
 *  modificarlo siempre que se respeten los terminos de la licencia
 *  GNU GLP version 2 o superior, publicada por la Free Software Foundation.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <malloc.h>
#include <netdb.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <fcntl.h>
#include <signal.h>
#include <errno.h>

#include <ncurses.h>

#define SIZEMSG 87

char sPuntos[5] ;
char sJuegos[4] ;
char sVacas[4] ;
char sJugador1[19] ;
char sJugador3[19] ;
char sCompa[19] ;
char sPrivada[4] ;
char sPartida[19] ;
char nPartida[4] ;
char sJugador[19] ;
char sHost[43] ;
char sPort[8] ;
char sConfirma[2] ;
int SocketMus ;
char Buffer[4096] ;
char Buffer2[4096] ;
char Buffer3[4096] ;
char Buffer4[4096] ;
int QuienSoy ; /* Mi numero de jugador en la partida */
int MisCartas[4] ;
char Jugadores[4][17] ;

int Tubo ;
int Debug = 0 ;
void Envia( char *Mensaje )
{
 memset( Buffer2, ' ', SIZEMSG ) ;
 Buffer2[ SIZEMSG-1] = '\n' ;
 memcpy( Buffer2, Mensaje, strlen( Mensaje ) ) ;
 send( SocketMus,Buffer2,SIZEMSG, MSG_NOSIGNAL ) ;
}

char *Trim( char *Texto )
{
 int j ;
 j = strlen( Texto )-1 ;
 while( j>=0 && (Texto[j] == ' ' || Texto[j] == '\n') ) j-- ;
 if( j >= -1 ) Texto[j+1] = 0 ;
 return Texto ;
}

char *SubStr( char *Texto, int Inicio, int Longitud ) 
{
 int j,k=0 ;
 j = Inicio ;
 while( k<Longitud ) Buffer3[k++] = Texto[j++] ;
 Buffer3[k] = 0 ;
 return Buffer3 ;
}

char *Cartas( char *Cuales )
{
 switch( atoi(Cuales) % 10 )
 {
  case 1: strcpy( Buffer4, "AS DE " ) ; break ;
  case 2: strcpy( Buffer4, "2 DE " ) ; break ;
  case 3: strcpy( Buffer4, "3 DE " ) ; break ;
  case 4: strcpy( Buffer4, "4 DE " ) ; break ;
  case 5: strcpy( Buffer4, "5 DE " ) ; break ;
  case 6: strcpy( Buffer4, "6 DE " ) ; break ;
  case 7: strcpy( Buffer4, "7 DE " ) ; break ;
  case 8: strcpy( Buffer4, "SOTA DE " ) ; break ;
  case 9: strcpy( Buffer4, "CABALLO DE " ) ; break ;
  case 0: strcpy( Buffer4, "REY DE " ) ; break ;
 }
 switch( (atoi(Cuales)-1) / 10 )
 {
  case 0: strcat( Buffer4, "OROS" ) ; break ;
  case 1: strcat( Buffer4, "COPAS" ) ; break ;
  case 2: strcat( Buffer4, "ESPADAS" ) ; break ;
  case 3: strcat( Buffer4, "BASTOS" ) ; break ;
 }
return Buffer4 ;
}

void TrataMensaje( char *Mensaje )
{
 int j ;
 char Kad1[20],Kad2[20] ;

 if( Debug )
  printw("*Debug: recv[%s]\n",Trim( Mensaje ) ) ;

 switch( Mensaje[0] )
 {
  case 'C': /* EMPIEZA PARTIDA */
	QuienSoy= Mensaje[5]-'0' ;
	strcpy( Jugadores[0],SubStr( Mensaje,6,16 ) ) ;
	strcpy( Jugadores[1],SubStr( Mensaje,22,16 ) ) ; 
	strcpy( Jugadores[2],SubStr( Mensaje,38,16 ) ) ;
	strcpy( Jugadores[3],SubStr( Mensaje,54,16 ) ) ;

	printw( "RECIBIDO: La partida ha comenzado: Se juega a %c vacas, con %c juegos por vaca\n",
		Mensaje[1],Mensaje[2] ) ;
	printw( "          y con %s puntos por juego. La posicion en la mesa es la siguiente:\n", SubStr( Mensaje,3,2) ) ;
	printw( "\n                      %s\n",Jugadores[0] ) ;
	printw( "\n%s                            %s\n",Jugadores[1],Jugadores[3] ) ;
	printw( "\n                      %s\n", Jugadores[2] ) ;
	break ;

  case 'L' : /* ALGUIEN ENVIA MENSAJE DE CHAT */
	Trim( Mensaje ) ;
	printw( "RECIBIDO: Mensaje chat de %s: %s\n",Jugadores[Mensaje[1]-'0'] ,Mensaje+2 ) ;
	break ;

  case 'B' : /* LA PARTIDA HA SIDO CANCELADA */
	printw( "RECIBIDO: La partida ha sido cancelada: ( %s )\n",Trim( Mensaje+1) ) ;
	printw( "Pulse casi cualquier tecla para salir..." ) ;
	while( getch() == ERR ) j=j ; /*SILLY THING*/
	endwin() ;
	exit( -21 ) ;
	break ;

  case 'I' : /* ME DAN MIS CARTAS */
	printw( "RECIBIDO: Mis cartas: %s - ", Cartas(SubStr(Mensaje,10,2))) ;
	printw( "%s - ", Cartas(SubStr(Mensaje,12,2))) ;
	printw( "%s - ", Cartas(SubStr(Mensaje,14,2))) ;
	printw( "%s\n", Cartas(SubStr(Mensaje,16,2))) ;
	printw( "Equipo 1 (%s-%s) lleva %s Puntos, %c Juegos y %c vacas\n",
		Jugadores[0], Jugadores[2],SubStr( Mensaje,5,2 ), Mensaje[3], Mensaje[1] ) ;
	printw( "Equipo 2 (%s-%s) lleva %s Puntos, %c Juegos y %c vacas\n",
		Jugadores[1],Jugadores[3],SubStr( Mensaje,7,2 ), Mensaje[4], Mensaje[2] ) ;
	printw( "El jugador Mano es: %s\n",Jugadores[Mensaje[9]-'0'] ) ;
	MisCartas[0] = atoi( SubStr(Mensaje,10,2) ) ;
	MisCartas[1] = atoi( SubStr(Mensaje,12,2) ) ;
	MisCartas[2] = atoi( SubStr(Mensaje,14,2) ) ;
	MisCartas[3] = atoi( SubStr(Mensaje,16,2) ) ;
	break ;

  case 'Q' : /* ME PREGUNTAN SI QUIERO MUS */
	printw( "RECIBIDO: Te toca indicar si quieres mus o no (pulsa 'm' o 'n').\n" ) ;
	break ;

  case 'X' : /* ME DICEN QUE ALGUIEN QUIERE MUS O NO */
	printw( "RECIBIDO: Jugador %s %s quiere MUS.\n",Jugadores[Mensaje[1]-'0'],(Mensaje[2]=='1'?"SI":"NO") ) ;
	break ;

  case 'D' : /* ME PREGUNTAN DE QUE CARTAS ME DESCARTO */
	printw( "RECIBIDO: Te toca indicar que cartas tiras. (pulsa 'd')\n" ) ;
	break ;

  case 'V' : /* ME DICEN CUANTAS CARTAS HA TIRADO UN JUGADOR */
	printw( "RECIBIDO: Jugador %s se descarta de %c cartas.\n",Jugadores[Mensaje[1]-'0'],Mensaje[2] ) ;
	break ;

  case 'W' : /* ME DICEN CUALES SON MIS NUEVAS CARTAS */
	MisCartas[0] = atoi( SubStr(Mensaje,1,2) ) ;
	MisCartas[1] = atoi( SubStr(Mensaje,3,2) ) ;
	MisCartas[2] = atoi( SubStr(Mensaje,5,2) ) ;
	MisCartas[3] = atoi( SubStr(Mensaje,7,2) ) ;
	printw( "RECIBIDO: Mis cartas ahora son: " ) ;
	printw( "%s - ", Cartas(SubStr(Mensaje,1,2))) ;
	printw( "%s - ", Cartas(SubStr(Mensaje,3,2))) ;
	printw( "%s - ", Cartas(SubStr(Mensaje,5,2))) ;
	printw( "%s\n", Cartas(SubStr(Mensaje,7,2))) ;
	break ;

  case 'A' : /* ME DICEN QUE HABLE, ENVIDO, PASO O QUE */
	if( Mensaje[1]-'0' == QuienSoy )
	 printw( "RECIBIDO: (Pulse p,e,s,v,o). Te toca hablar de " )  ;
	else
	 printw( "RECIBIDO: Le toca hablar a %s de ",Jugadores[Mensaje[1]-'0'] )  ;
	if( Mensaje[2] == '1' ) printw( "GRANDE." ) ;
	if( Mensaje[2] == '2' ) printw( "CHICA." ) ;
	if( Mensaje[2] == '3' ) printw( "PARES." ) ;
	if( Mensaje[2] == '4' ) printw( "JUEGO." ) ;
	if( Mensaje[2] == '5' ) printw( "PUNTO." ) ;
	Buffer4[0] = Mensaje[7] ; Buffer4[1] = Mensaje[8] ; Buffer4[2] = 0 ;
	printw( "\nPuntos Envidados %d. ", atoi( Buffer4 ) ) ;
	Buffer4[0] = Mensaje[9] ; Buffer4[1] = Mensaje[10] ; Buffer4[2] = 0 ;
	printw( "Puntos vistos de momento %d.\nPuede ", atoi( Buffer4 ) ) ;
	if( Mensaje[3]== '1' ) printw( "Envidar, " ) ;
	if( Mensaje[4]== '1' ) printw( "Subir, " ) ;
	if( Mensaje[5]== '1' ) printw( "Ver, " ) ;
	if( Mensaje[6]== '1' ) printw( "dar Ordago, " ) ;
	printw( " o Pasar.\n" ) ;
	break ;

  case 'E' : /* ME DICEN QUE ACCION HA DICHO UN JUGADOR, SI ENVIDA; PASA O QUE */
	printw( "RECIBIDO: Jugador %s ",Jugadores[Mensaje[1]-'0'] ) ;
	if( Mensaje[2]=='E' )
	{
	 Buffer4[0] = Mensaje[3] ; Buffer4[1] = Mensaje[4] ; Buffer4[2] = 0 ;
	 printw( "ENVIDA %d. ", atoi( Buffer4 ) ) ;
	}
	else
	 if( Mensaje[2] == 'P' )
	   printw( "PASA. " ) ;
	 else
	  if( Mensaje[2] == 'V' )
	   printw( "VE. " ) ;
	  else
	   if( Mensaje[2] == 'O' )
	    printw( "da ORDAGO. " ) ;
	   else
	    if( Mensaje[2] == 'S' )
	    {
	     Buffer4[0] = Mensaje[3] ; Buffer4[1] = Mensaje[4] ; Buffer4[2] = 0 ;
	     printw( "SUBE %d. ", atoi( Buffer4 ) ) ;
	    }
	Buffer4[0] = Mensaje[5] ; Buffer4[1] = Mensaje[6] ; Buffer4[2] = 0 ;
	printw( "\nEquipo 1 (%c-%c) lleva %d punto(s).\n", Jugadores[0][0],Jugadores[2][0],atoi( Buffer4 ) ) ;
	Buffer4[0] = Mensaje[7] ; Buffer4[1] = Mensaje[8] ; Buffer4[2] = 0 ;
	printw( "Equipo 2 (%c-%c) lleva %d punto(s).\n", Jugadores[1][0],Jugadores[3][0],atoi( Buffer4 ) ) ;
	break ;

  case 'P' : /* FIN DE UNA RONDA */
	printw( "RECIBIDO: Fin de esta ronda. Las cartas que tenian eran:\n" ) ;
	printw( "         %s: %s",Jugadores[0],Cartas( SubStr(Mensaje,1,2))) ;
	printw( " - %s\n                           ",Cartas(SubStr(Mensaje,3,2))) ;
	printw( "%s", Cartas(SubStr(Mensaje,5,2))) ;
	printw( " - %s\n", Cartas(SubStr(Mensaje,7,2))) ;
	printw( "%16s:                    %16s:\n",Jugadores[1],Jugadores[3] ) ;
	printw( "%18s                 ", Cartas( SubStr(Mensaje,9,2) ) ) ;
	printw( "%18s\n", Cartas( SubStr( Mensaje,25,2)) ) ;
	printw( "%18s                 ", Cartas( SubStr(Mensaje,11,2) ) ) ;
	printw( "%18s\n", Cartas( SubStr( Mensaje,27,2)) ) ;
	printw( "%18s                 ", Cartas( SubStr(Mensaje,13,2) ) ) ;
	printw( "%18s\n", Cartas( SubStr( Mensaje,29,2)) ) ;
	printw( "%18s                 ", Cartas( SubStr(Mensaje,15,2) ) ) ;
	printw( "%18s\n", Cartas( SubStr( Mensaje,31,2)) ) ;
	printw( "         %s: %s",Jugadores[2],Cartas( SubStr(Mensaje,17,2))) ;
	printw( " - %s\n                           ",Cartas(SubStr(Mensaje,19,2))) ;
	printw( "%s - ", Cartas(SubStr(Mensaje,21,2))) ;
	printw( "%s\n", Cartas(SubStr(Mensaje,23,2))) ;
	sprintf( Kad1,"%c%c-%c%c",Jugadores[0][0],Jugadores[0][1],Jugadores[2][0],Jugadores[2][1] ) ;
	sprintf( Kad2,"%c%c-%c%c",Jugadores[1][0],Jugadores[1][1],Jugadores[3][0],Jugadores[3][1] ) ;
	printw( "GANADORES: Grande:%s",(Mensaje[33]=='1'?Kad1:(Mensaje[33]=='2'?Kad2:"No")));
        printw( " Chica:%s",(Mensaje[36]=='1'?Kad1:(Mensaje[36]=='2'?Kad2:"No") ) );
        printw( " Pares:%s",(Mensaje[39]=='1'?Kad1:(Mensaje[39]=='2'?Kad2:"No") ) );
        printw( " Juego/Punto:%s\n",(Mensaje[43]=='1'?Kad1:(Mensaje[43]=='2'?Kad2:"No") ) );
	printw( "Sumar Puntos por: Grande: %c%c Chica:%c%c Pares:%c%c Juego/Punto:%c%c\n",
		Mensaje[34],Mensaje[35],Mensaje[37],Mensaje[38],Mensaje[40],Mensaje[41],
		Mensaje[44],Mensaje[45] ) ;
	if( Mensaje[47]== '1' ) printw( "Ha ganado este juego la pareja %s\n",Kad1 ) ;
	if( Mensaje[47]== '2' ) printw( "Ha ganado este juego la pareja %s\n",Kad2 ) ;
	if( Mensaje[48]== '1' ) printw( "Ha ganado esta vaca la pareja %s\n",Kad1 ) ;
	if( Mensaje[48]== '2' ) printw( "Ha ganado esta vaca la pareja %s\n",Kad2 ) ;
	break ;

  case 'K' : /* FIN DE PARTIDA */
	printw( "RECIBIDO: La partida ha finalizado. Gracias por jugar.\n" ) ;
	if( Mensaje[1] == '1' )
          printw( "Ha ganado la pareja: %s - %s .\n" , Jugadores[0], Jugadores[2] ) ;
	else
          printw( "Ha ganado la pareja: %s - %s .\n" , Jugadores[1], Jugadores[3] ) ;
	printw( "Pulse casi cualquier tecla para salir..." ) ;
	while( getch() == ERR ) j=j ; /*SILLY THING*/
	endwin() ;
	exit( -21 ) ;
	break ;
 }
}


int main( int argc, char **argv )
{
 int j, k;
 struct hostent * hp ;
 struct sockaddr_in host ;
 
 initscr();
 start_color() ;
 cbreak();
 nonl();
 intrflush(stdscr, FALSE);
 keypad(stdscr, TRUE);
 idlok( stdscr, TRUE ) ;
 scrollok( stdscr, TRUE ) ;

 sConfirma[0] = 'n' ;
 while( sConfirma[0] == 'n' || sConfirma[0] == 'N' )
 {
  clear() ;

  if( argc > 1 )
   if( strcmp( argv[1],"-d" ) == 0 )
    { Debug = 1 ; printw( "(Debug)" ) ; }
 
  printw( "   -=< Bienvenido al programa cliente para pruebas del SERVIDOR DE MUS >=-\n" ) ; 
  printw( "Introduce tu nombre de jugador (16 caracteres maximo) :\n" ) ;
  printw( "Nombre o IP del servidor de Mus [localhost]           :\n" ) ;
  printw( "Numero de puerto por el que escucha el servidor [4321]:\n" ) ;  
  printw( "Quieres crear una partida nueva (S/[N]) ?             :\n" ) ;
  printw( "Nombre de la partida de mus (16 carac. max.) [prueba] :" ) ;
  move( 1,55 ) ;
  getnstr( sJugador, 16 ) ;
  move( 2,55 ) ;
  getnstr( sHost, 40 ) ;
  if( sHost[0] == 0 )
    strcpy( sHost,"localhost" ) ;
  move( 3,55 ) ;
  getnstr( sPort, 5 ) ;
  if( sPort[0] == 0 )
    strcpy( sPort, "4321" ) ;
  move( 4,55 ) ;
  getnstr( nPartida, 1 ) ;
  move( 5,55 ) ;
  getnstr( sPartida, 16 ) ;
  if( sPartida[0] == 0 )
    strcpy( sPartida, "prueba" ) ;
  if( nPartida[0] == 's' || nPartida[0] == 'S' )
  {
   printw( "A cuantas vacas se juega esta partida  :\n" ) ;
   printw( "Con cuantos juegos se alcanza una vaca :\n" ) ;
   printw( "Con cuantos puntos se gana un juego    :\n" ) ;
   printw( "Es una partida privada (Solo se pueden apuntar los que tu digas) (s/[n]) ?" ) ;
   move( 6,40 ) ;
   getnstr( sVacas, 1 ) ;
   move( 7,40 ) ;
   getnstr( sJuegos, 1 ) ;
   move( 8,40 ) ;
   getnstr( sPuntos, 2 ) ;
   move( 9,74 ) ;
   getnstr( sPrivada,1 ) ;
   if( sPrivada[0] == 's' || sPrivada[0] == 'S' )
   {
    printw( "Nombre de tu compaero de juego (16 carac. max.) :\n" ) ;
    printw( "Nombre del tercer jugador(16 carac. max)         :\n" ) ;
    printw( "Nombre del cuarto jugador(16 carac. max)         :" ) ;
    move( 10,50 ) ;
    getnstr( sCompa, 16 ) ;
    move( 11,50 ) ;
    getnstr( sJugador1, 16 ) ;
    move( 12,50 ) ;
    getnstr( sJugador3, 16 ) ;
   }
  }
  printw( "De acuerdo con esta informacin ([s]/n) ?" ) ;
  getnstr( sConfirma,1 ) ;
 }

 nodelay( stdscr, TRUE ) ;

 /* Compruebo que ha respondido a todas mis preguntas */
 /* DE MOMENTO NO TENGO TIEMPO DE COMPROBAR NADDA */

 /* Ajustar los nombres a los 16 caracteres que marca la ley!! */
 
 sprintf( Buffer,"%s                ",sPartida ) ; Buffer[16] = 0 ;
 strcpy( sPartida,Buffer ) ;
 sprintf( Buffer,"%s                ",sJugador ) ; Buffer[16] = 0 ;
 strcpy( sJugador,Buffer ) ;
 sprintf( Buffer,"%s                ",sCompa ) ; Buffer[16] = 0 ;
 strcpy( sCompa,Buffer ) ;
 sprintf( Buffer,"%s                ",sJugador1 ) ; Buffer[16] = 0 ;
 strcpy( sJugador1,Buffer ) ;
 sprintf( Buffer,"%s                ",sJugador3 ) ; Buffer[16] = 0 ;
 strcpy( sJugador3,Buffer ) ;

 clear() ;

 /* Ahora me conecto al servidor de mus */

 hp = (struct hostent *)gethostbyname( sHost ) ;
 if( !hp || !atoi( sPort ) || !sJugador[0] || !sPartida[0] )
 {
  printw( "Datos erroneos o host inexistente\n" ) ;
  while( getch() == ERR ) j=j ; /*SILLY THING*/
  endwin() ;
  exit ( -4 ) ;
 }

 SocketMus = socket( AF_INET, SOCK_STREAM, 0 ) ;

  memset( &host, 0, sizeof(host) ) ;
  host.sin_family = AF_INET ;
  host.sin_port = htons( atoi(sPort) ) ;
  host.sin_addr = *(( struct in_addr *)hp->h_addr) ;

 j = connect( SocketMus, (struct sockaddr *)&host, sizeof( host ) ) ;
 if( j<0 )
 {
  printw( "Error: Imposible conectarse al servidor\nPulse una tecla..." ) ;
  while( getch() == ERR ) j=j ; /*SILLY THING*/
  endwin() ;
  exit( -5 ) ;
 }

 /* Ahora registro la partida */
 if( nPartida[0] == 's' || nPartida[0] == 'S' ) /* REGISTRAR PARTIDA NUEVA */
 {
  if( sPrivada[0] == 's' || sPrivada[0] == 'S' )/* REGISTRAR PARTIDA PRIVADA */
   {
    sprintf( Buffer,"N%16s%1s%1s%2s1%16s%16s%16s%16s",sPartida,sVacas,sJuegos,sPuntos,sJugador,sCompa,sJugador1,sJugador3 ) ;
    printw( "Enviando solicitud de registro de partida privada...\n" ) ;
    Envia( Buffer ) ;
   }
   else /* REGISTRAR PARTIDA PUBLICA */
   {
    sprintf( Buffer,"N%16s%1s%1s%2s0%16s%16s%16s%16s",sPartida,sVacas,sJuegos,sPuntos,sJugador,"","","" ) ;
    printw( "Enviando solicitud de registro de partida publica...\n" ) ;
    Envia( Buffer ) ;
   }
 }
 else /* APUNTARSE A UNA PARTIDA */
 {
    sprintf( Buffer,"A%16s%16s",sPartida,sJugador ) ;
    printw( "Enviando solicitud de apuntarse a partida...\n" ) ;
    Envia( Buffer ) ;
 }

/* ESPERO CONFIRMACION DEL APUNTADO */
 j = recv( SocketMus, Buffer, SIZEMSG, 0 ) ;
 if( j > 0 )
  {
    Buffer[j]=0 ;
    printw( "Respuesta: " ) ;
    if( Buffer[1] == '1' )
      printw( "Solicitud aceptada: Esperando Inicio de partida..." ) ;
    else
     {
       printw( "Solicitud denegada (%s): Acabando programa.\nPulse una tecla...",Buffer+2 ) ;
       while( getch() == ERR ) j=j ; /*SILLY THING*/
       endwin() ;
       close( SocketMus ) ;
       exit( -9 ) ;
     }
  }
 else
  {
   printw( "Error: no se recibio respuesta del servidor a la peticion.\nPulse una tecla..." ) ;
   while( getch() == ERR ) j=j ; /*SILLY THING*/
   endwin() ;
   exit( -8 ) ;
  }
 /* Y ahora empieza lo bueno */

 fcntl( SocketMus, F_SETFL, FNDELAY ) ;
 printw( "\nPULSAR: 'q' para acabar.\n  'c' para enviar mensaje chat al resto jugadores.\n  'm' para pedir mus." ) ;
 printw( "\n  'n' para NO mus.\n  'd' para indicar el descarte.\n  'e' para envidar.\n  'p' para pasar." ) ;
 printw( "\n  's' para subir.\n  'o' para ordago.\n  'v' para ver envite u ordago.") ;
 printw( "\n  'k' para ver sus cartas.   (No hay seas de momento. lo siento.) :-(\n" ) ;
 while ( 1 /* TRUE */ )
 {
  if( (j = getch()) == ERR )
  {              /* LEER DEL SOCKET A VER QUE HAY */
    j = recv( SocketMus, Buffer, SIZEMSG, 0 ) ;
    if( j > 0 )
     {
      Buffer[j] = 0 ;
      TrataMensaje( Buffer ) ;
     }
    else
     if( !j )
       {
	printw( "Error: La comunicacion ha sido cerrada. Fin del juego.\nPulse una tecla..." ) ;
	while( getch() == ERR ) j=j ; /*SILLY THING*/
	endwin() ;
	exit( -10 ) ;
       }
  }
  else /* A VER QUE TECLA HA PULSADO */ 
  {
   switch( j )
   {
    case 'q' :
    case 'Q' : endwin() ;
		Envia( "F" ) ;
		close( SocketMus ) ;
		exit ( 0 ) ;
		break ;
    case 'c' :
    case 'C' :
		Buffer[0] = 'M' ;
		printw( "\rMsg a enviar:" ) ;
		nodelay( stdscr, FALSE ) ;
		getnstr( Buffer+1, 80 ) ;
		nodelay( stdscr, TRUE ) ;
		if( Buffer[1] ) Envia( Buffer ) ;
		break ;
    case 'm' :
    case 'M' : printw( "\rENVIADO: Vd. quiere mus\n" ) ;
		Envia( "T1" ) ;
		break ;
    case 'n' :
    case 'N' : printw( "\rENVIADO: No hay MUS\n" ) ;
		Envia( "T0" ) ;
		break ;
    case 'd' :
    case 'D' : sprintf( Buffer, "\r%d",MisCartas[0] ) ;
		printw( " Elija lar cartas a tirar:\n 1 - %s\n",Cartas(Buffer) ) ;
		sprintf( Buffer, "%d",MisCartas[1] ) ;
		printw( " 2 - %s\n", Cartas(Buffer) ) ;
		sprintf( Buffer, "%d",MisCartas[2] ) ;
		printw( " 3 - %s\n", Cartas(Buffer) ) ;
		sprintf( Buffer, "%d",MisCartas[3] ) ;
		printw( " 4 - %s\n", Cartas(Buffer) ) ;
		printw( "   Teclee los numeros de las cartas a tirar (sin separacion) :" ) ;
		nodelay( stdscr, FALSE ) ;
		Buffer[1] = Buffer[2] = Buffer[3] = 0 ;
		getnstr( Buffer,4 ) ;
		nodelay( stdscr, TRUE ) ;
		if( Buffer[0] == 0 && isdigit( Buffer[0] ) )
		 printw( "ERROR: Debe indicar al menos una carta. Pulse otra vez 'd' para descarte.\n" ) ;
		else
		 {
		  printw( "ENVIADO: Descarte\n" ) ; 
		  sprintf( Buffer3, "U%1d%2d%2d%2d%2d",strlen(Buffer),MisCartas[Buffer[0]-'1'],
			isdigit(Buffer[1])?MisCartas[Buffer[1]-'1']:0,
			isdigit(Buffer[2])?MisCartas[Buffer[2]-'1']:0,
			isdigit(Buffer[3])?MisCartas[Buffer[3]-'1']:0 ) ;
		  Envia( Buffer3 ) ;
		 }
		break ;
	case 'e' :
	case 'E' :
		printw( "\rCuanto envida ('x' para cancelar)? [2]:" ) ;
		nodelay( stdscr, FALSE ) ;
		Buffer[1] = Buffer[2] = Buffer[3] = 0 ;
		getnstr( Buffer,2 ) ;
		nodelay( stdscr, TRUE ) ;
		if( Buffer[0] == 0 ) { Buffer[0] = '2' ; Buffer[1] = 0 ; }
		if( atoi( Buffer ) > 1 )
		 {
		  sprintf( Buffer3, "HE%2d" , atoi( Buffer ) ) ;
		  Envia( Buffer3 ) ;
		 }
		break ;
	case 'p' :
	case 'P' :
		printw( "\rPasar (S/N)? [S]:") ;
		nodelay( stdscr, FALSE ) ;
		Buffer[1] = Buffer[2] = Buffer[3] = 0 ;
		getnstr( Buffer,1 ) ;
		nodelay( stdscr, TRUE ) ;
		if( Buffer[0] == 0 || Buffer[0] == 'S' || Buffer[0] == 's' )
		 Envia( "HP  " ) ;
		break ;
	case 's' :
	case 'S' :
		printw( "\rCuanto sube ('x' para cancelar)? [1]:" ) ;
		nodelay( stdscr, FALSE ) ;
		Buffer[1] = Buffer[2] = Buffer[3] = 0 ;
		getnstr( Buffer,2 ) ;
		nodelay( stdscr, TRUE ) ;
		if( Buffer[0] == 0 ) { Buffer [0] = '1' ; Buffer[1] = 0 ; }
		if( atoi( Buffer ) > 0 )
		 {
		  sprintf( Buffer3, "HS%2d" , atoi( Buffer ) ) ;
		  Envia( Buffer3 ) ;
		 }
		break ;
	case 'o' :
	case 'O' :
		printw( "\rDar ORDAGO!! (S/N)? [S]:") ;
		nodelay( stdscr, FALSE ) ;
		Buffer[1] = Buffer[2] = Buffer[3] = 0 ;
		getnstr( Buffer,1 ) ;
		nodelay( stdscr, TRUE ) ;
		if( Buffer[0] == 0 || Buffer[0] == 'S' || Buffer[0] == 's' )
		 Envia( "HO  " ) ;
		break ;
	case 'v' :
	case 'V' :
		printw( "\rVer envite (S/N)? [S]:") ;
		nodelay( stdscr, FALSE ) ;
		Buffer[1] = Buffer[2] = Buffer[3] = 0 ;
		getnstr( Buffer,1 ) ;
		nodelay( stdscr, TRUE ) ;
		if( Buffer[0] == 0 || Buffer[0] == 'S' || Buffer[0] == 's' )
		 Envia( "HV  " ) ;
		break ;
    case 'k' :
    case 'K' :  sprintf( Buffer, "%d",MisCartas[0] ) ;
		printw( "\r 1 - %s\n",Cartas(Buffer) ) ;
		sprintf( Buffer, "%d",MisCartas[1] ) ;
		printw( " 2 - %s\n", Cartas(Buffer) ) ;
		sprintf( Buffer, "%d",MisCartas[2] ) ;
		printw( " 3 - %s\n", Cartas(Buffer) ) ;
		sprintf( Buffer, "%d",MisCartas[3] ) ;
		printw( " 4 - %s\n", Cartas(Buffer) ) ;
		break ;

    case 'h' :
    case 'H' :
 printw( "\nPULSAR: 'q' para acabar.\n  'c' para enviar mensaje chat al resto jugadores.\n  'm' para pedir mus." ) ;
 printw( "\n  'n' para NO mus.\n  'd' para indicar el descarte.\n  'e' para envidar.\n  'p' para pasar." ) ;
 printw( "\n  's' para subir.\n  'o' para ordago.\n  'v' para ver envite u ordago.") ;
 printw( "\n  'k' para ver sus cartas.   (No hay seas de momento. lo siento.) :-(\n" ) ;
	break ;
   }
  }

 }
 
 endwin() ;
}
