/*  Cliente de partidas de mus. Jumus
 *  Autor: Antonio Garcia
 *         angarcia@openbank.es
 *  Copyright (C) 2000  Antonio Garcia
 *
 *  Este programa es Software Libre. Puedes usarlo, redistribuirlo o
 *  modificarlo siempre que se respeten los terminos de la licencia
 *  GNU GPL version 2 o (a su eleccion) otra posterior, publicada por
 *  la Free Software Foundation.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA  
 */

import java.applet.*;
import java.awt.*;
import java.net.*;
import java.io.* ;
/**
 * Jumus es un applet Java que funciona como cliente del programa
 * servidor de partidas de mus "sumus". Es decir, sirve para jugar
 * al mus en internet.
 * Este programa es GPL. Tengo que poner aqui la licencia, bla bla bla.
 *
 * Creation date: (05/13/00 19:31:12)
 * @author: Antonio Garcia (Angarcia@openbank.es)
 */
public class Jumus extends Applet implements Runnable {
	private Button ivjbAbandonar = null;
	private Button ivjbOrdago = null;
	private Button ivjbVeo = null;
	private Label ivjLabel1 = null;
	private Label ivjLabel2 = null;
	private Label ivjLabel3 = null;
	private Label ivjLabel4 = null;
	private Label ivjLabel5 = null;
	private Label ivjLabel7 = null;
	private Panel ivjPanel1 = null;
	private Button ivjbEnvido = null;
	private Button ivjbEnvioChat = null;
	private Button ivjbPaso = null;
	private Button ivjbSubo = null;
	private List ivjlChat = null;
	private Label ivjlJuegosPareja1 = null;
	private Label ivjlJugador0 = null;
	private Label ivjlJugador2 = null;
	private Label ivjlPuntosPareja1 = null;
	private TextField ivjtEnvioChat = null;
	private Label ivjLabel31 = null;
	private Label ivjLabel41 = null;
	private Label ivjLabel51 = null;
	private Label ivjLabel71 = null;
	private Label ivjlJuegosPareja2 = null;
	private Label ivjlJugador1 = null;
	private Label ivjlJugador3 = null;
	private Label ivjlJugadorAbajo = null;
	private Label ivjlJugadorArriba = null;
	private Label ivjlJugadorDerecha = null;
	private Label ivjlJugadorIzquierda = null;
	private Label ivjlPuntosPareja2 = null;
	private Label ivjlVacasPareja1 = null;
	private Label ivjlVacasPareja2 = null;
	private Label ivjlEstadoBaza2 = null;
	private TextArea ivjtInformaTanteo = null;
	private TextArea ivjtInforma = null;
	private TextArea ivjtInformaAntes = null;
	IvjEventHandler ivjEventHandler = new IvjEventHandler();
	private Button ivjbMusNO = null;
	private Button ivjbMusSI = null;
	private Label ivjlMazo = null;
/**
 * longmsg - es la longitud (fija) de los mensajes servidor <--> cliente
 */
public static int longmsg = 87 ;
/**
 * Variable de 4 enteros para almacenar las cartas que me reparten en cada baza
 */
public int[] misCartas;
/**
 * Array de 4 Strings para almacenar los nombres de los jugadores.
 */
public java.lang.String[] nombreJugadores;
/**
 * Numero de jugador 0->4 que el servidor me asigna.
 */
public int numJugador = 0 ;

public int mano = -1 ;
public int baza = -1 ;
public String ultimoEnvite = null ;
public String textoBaza = null ;
public int ponQuien = 0 ;
public int esperoClick = 0 ;
public String oldRespuesta = "" ;

static final int DESCARTE = 0 ;
static final int GRANDE = 1 ;
static final int CHICA = 2 ;
static final int PARES = 3 ;
static final int JUEGO = 4 ;
static final int PUNTO = 5 ;

public int [] seleccionDescarte ;

/**
 * Socket y Streams de entrada/salida por el que me conecto al servidor
 * por defecto TCP/1234. 
 */
public Socket canuto = null ;
public BufferedReader is = null ;
public DataOutputStream os = null ;
public Thread threadCanuto = null ;
public String esp16 ;
public String esp86 ;

/* Imagenes para pintar cartas y otros. */
public Image gEnvesh = null ;
public Image gEnvesv = null  ;
public Image gMano = null ;
public Image gOroh = null ;
public Image gOrov = null ;
public Image gCopah = null ;
public Image gCopav = null ;
public Image gEspadah = null ;
public Image gEspadav = null ;
public Image gBastoh = null ;
public Image gBastov = null ;
public Image gSotah = null ;
public Image gSotav  = null ;
public Image gCaballoh = null ;
public Image gCaballov = null ;
public Image gReyh = null ;
public Image gReyv = null ;
/* Variables que me pasa el HTML */
public String nombre;
public String puerto;
public String nombrePartida;
public String esNueva;
public String numVacas;
public String numJuegos;
public String numPuntos;
public String esPrivada;
public String jugador3;
public String jugador2;
public String jugador4;
public String servidor;

public int pp = 1 ;

/* Coordenadas de las cartas en pantalla */
public int[] coorX = { 92,138,184,230 };
public int[] coorY = { 92,138,208,254 };

class IvjEventHandler implements java.awt.event.ActionListener, java.awt.event.MouseListener {
		public void actionPerformed(java.awt.event.ActionEvent e) {
			if (e.getSource() == Jumus.this.getbAbandonar()) 
				connEtoM1(e);
			if (e.getSource() == Jumus.this.getbOrdago()) 
				connEtoM2(e);
			if (e.getSource() == Jumus.this.getbVeo()) 
				connEtoM3(e);
			if (e.getSource() == Jumus.this.getbSubo()) 
				connEtoM4(e);
			if (e.getSource() == Jumus.this.getbEnvido()) 
				connEtoM5(e);
			if (e.getSource() == Jumus.this.getbPaso()) 
				connEtoM6(e);
			if (e.getSource() == Jumus.this.getbEnvioChat()) 
				connEtoM7(e);
			if (e.getSource() == Jumus.this.getbMusSI()) 
				connEtoM8(e);
			if (e.getSource() == Jumus.this.getbMusNO()) 
				connEtoM9(e);
		};
		public void mouseClicked(java.awt.event.MouseEvent e) {
			if (e.getSource() == Jumus.this) 
				connEtoC1(e);
		};
		public void mouseEntered(java.awt.event.MouseEvent e) {};
		public void mouseExited(java.awt.event.MouseEvent e) {};
		public void mousePressed(java.awt.event.MouseEvent e) {};
		public void mouseReleased(java.awt.event.MouseEvent e) {};
	};
	private Label ivjlEstadoBaza = null;
	private TextField ivjtCantidad = null;
/**
 * connEtoC1:  (Jumus.mouse.mouseClicked(java.awt.event.MouseEvent) --> Jumus.jumus_MouseClicked(Ljava.awt.event.MouseEvent;)V)
 * @param arg1 java.awt.event.MouseEvent
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void connEtoC1(java.awt.event.MouseEvent arg1) {
	try {
		// user code begin {1}
		// user code end
		this.jumus_MouseClicked(arg1);
		// user code begin {2}
		// user code end
	} catch (java.lang.Throwable ivjExc) {
		// user code begin {3}
		// user code end
		handleException(ivjExc);
	}
}
/**
 * connEtoM1:  (bAbandonar.action.actionPerformed(java.awt.event.ActionEvent) --> Jumus.saluda()V)
 * @param arg1 java.awt.event.ActionEvent
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void connEtoM1(java.awt.event.ActionEvent arg1) {
	try {
		// user code begin {1}
		// user code end
		this.abandono();
		// user code begin {2}
		// user code end
	} catch (java.lang.Throwable ivjExc) {
		// user code begin {3}
		// user code end
		handleException(ivjExc);
	}
}
/**
 * connEtoM2:  (bOrdago.action.actionPerformed(java.awt.event.ActionEvent) --> Jumus.ordago()V)
 * @param arg1 java.awt.event.ActionEvent
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void connEtoM2(java.awt.event.ActionEvent arg1) {
	try {
		// user code begin {1}
		// user code end
		this.ordago();
		// user code begin {2}
		// user code end
	} catch (java.lang.Throwable ivjExc) {
		// user code begin {3}
		// user code end
		handleException(ivjExc);
	}
}
/**
 * connEtoM3:  (bVeo.action.actionPerformed(java.awt.event.ActionEvent) --> Jumus.veo()V)
 * @param arg1 java.awt.event.ActionEvent
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void connEtoM3(java.awt.event.ActionEvent arg1) {
	try {
		// user code begin {1}
		// user code end
		this.veo();
		// user code begin {2}
		// user code end
	} catch (java.lang.Throwable ivjExc) {
		// user code begin {3}
		// user code end
		handleException(ivjExc);
	}
}
/**
 * connEtoM4:  (bSubo.action.actionPerformed(java.awt.event.ActionEvent) --> Jumus.subo()V)
 * @param arg1 java.awt.event.ActionEvent
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void connEtoM4(java.awt.event.ActionEvent arg1) {
	try {
		// user code begin {1}
		// user code end
		this.subo();
		// user code begin {2}
		// user code end
	} catch (java.lang.Throwable ivjExc) {
		// user code begin {3}
		// user code end
		handleException(ivjExc);
	}
}
/**
 * connEtoM5:  (bEnvido.action.actionPerformed(java.awt.event.ActionEvent) --> Jumus.envido()V)
 * @param arg1 java.awt.event.ActionEvent
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void connEtoM5(java.awt.event.ActionEvent arg1) {
	try {
		// user code begin {1}
		// user code end
		this.envido();
		// user code begin {2}
		// user code end
	} catch (java.lang.Throwable ivjExc) {
		// user code begin {3}
		// user code end
		handleException(ivjExc);
	}
}
/**
 * connEtoM6:  (bPaso.action.actionPerformed(java.awt.event.ActionEvent) --> Jumus.paso()V)
 * @param arg1 java.awt.event.ActionEvent
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void connEtoM6(java.awt.event.ActionEvent arg1) {
	try {
		// user code begin {1}
		// user code end
		this.paso();
		// user code begin {2}
		// user code end
	} catch (java.lang.Throwable ivjExc) {
		// user code begin {3}
		// user code end
		handleException(ivjExc);
	}
}
/**
 * connEtoM7:  (bEnvioChat.action.actionPerformed(java.awt.event.ActionEvent) --> Jumus.envioChat()V)
 * @param arg1 java.awt.event.ActionEvent
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void connEtoM7(java.awt.event.ActionEvent arg1) {
	try {
		// user code begin {1}
		// user code end
		this.envioChat();
		// user code begin {2}
		// user code end
	} catch (java.lang.Throwable ivjExc) {
		// user code begin {3}
		// user code end
		handleException(ivjExc);
	}
}
/**
 * connEtoM8:  (bMusSI.action.actionPerformed(java.awt.event.ActionEvent) --> Jumus.musSI()V)
 * @param arg1 java.awt.event.ActionEvent
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void connEtoM8(java.awt.event.ActionEvent arg1) {
	try {
		// user code begin {1}
		// user code end
		this.musSI();
		// user code begin {2}
		// user code end
	} catch (java.lang.Throwable ivjExc) {
		// user code begin {3}
		// user code end
		handleException(ivjExc);
	}
}
/**
 * connEtoM9:  (bMusNO.action.actionPerformed(java.awt.event.ActionEvent) --> Jumus.musNO()V)
 * @param arg1 java.awt.event.ActionEvent
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void connEtoM9(java.awt.event.ActionEvent arg1) {
	try {
		// user code begin {1}
		// user code end
		this.musNO();
		// user code begin {2}
		// user code end
	} catch (java.lang.Throwable ivjExc) {
		// user code begin {3}
		// user code end
		handleException(ivjExc);
	}
}
/**
 * Obtener informacion sobre el applet.
 * @return java.lang.String
 */
public String getAppletInfo() {
	return "Jumus - Cliente para jugar al mus en red" ;
}
/**
 * Return the Label1 property value.
 * @return java.awt.Label
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private Label getLabel1() {
	if (ivjLabel1 == null) {
		try {
			ivjLabel1 = new java.awt.Label();
			ivjLabel1.setName("Label1");
			ivjLabel1.setText("Cantidad:");
			ivjLabel1.setBackground(java.awt.Color.white);
			ivjLabel1.setBounds(126, 314, 59, 18);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjLabel1;
}
/**
 * Return the Label2 property value.
 * @return java.awt.Label
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private Label getLabel2() {
	if (ivjLabel2 == null) {
		try {
			ivjLabel2 = new java.awt.Label();
			ivjLabel2.setName("Label2");
			ivjLabel2.setFont(new java.awt.Font("monospaced", 1, 12));
			ivjLabel2.setAlignment(java.awt.Label.CENTER);
			ivjLabel2.setText("--------- CHAT ---------");
			ivjLabel2.setBounds(2, 96, 220, 18);
			ivjLabel2.setForeground(java.awt.Color.red);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjLabel2;
}
/**
 * Return the Label3 property value.
 * @return java.awt.Label
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private Label getLabel3() {
	if (ivjLabel3 == null) {
		try {
			ivjLabel3 = new java.awt.Label();
			ivjLabel3.setName("Label3");
			ivjLabel3.setFont(new java.awt.Font("monospaced", 1, 10));
			ivjLabel3.setText("Pareja 1:");
			ivjLabel3.setBounds(7, 5, 58, 18);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjLabel3;
}
/**
 * Return the Label31 property value.
 * @return java.awt.Label
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private Label getLabel31() {
	if (ivjLabel31 == null) {
		try {
			ivjLabel31 = new java.awt.Label();
			ivjLabel31.setName("Label31");
			ivjLabel31.setFont(new java.awt.Font("monospaced", 1, 10));
			ivjLabel31.setText("Pareja 2:");
			ivjLabel31.setBounds(7, 52, 58, 18);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjLabel31;
}
/**
 * Return the Label4 property value.
 * @return java.awt.Label
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private Label getLabel4() {
	if (ivjLabel4 == null) {
		try {
			ivjLabel4 = new java.awt.Label();
			ivjLabel4.setName("Label4");
			ivjLabel4.setFont(new java.awt.Font("monospaced", 1, 10));
			ivjLabel4.setText("Puntos:");
			ivjLabel4.setBounds(40, 33, 43, 18);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjLabel4;
}
/**
 * Return the Label41 property value.
 * @return java.awt.Label
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private Label getLabel41() {
	if (ivjLabel41 == null) {
		try {
			ivjLabel41 = new java.awt.Label();
			ivjLabel41.setName("Label41");
			ivjLabel41.setFont(new java.awt.Font("monospaced", 1, 10));
			ivjLabel41.setText("Puntos:");
			ivjLabel41.setBounds(40, 80, 43, 18);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjLabel41;
}
/**
 * Return the Label5 property value.
 * @return java.awt.Label
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private Label getLabel5() {
	if (ivjLabel5 == null) {
		try {
			ivjLabel5 = new java.awt.Label();
			ivjLabel5.setName("Label5");
			ivjLabel5.setFont(new java.awt.Font("monospaced", 1, 10));
			ivjLabel5.setText("Juegos:");
			ivjLabel5.setBounds(106, 33, 41, 18);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjLabel5;
}
/**
 * Return the Label51 property value.
 * @return java.awt.Label
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private Label getLabel51() {
	if (ivjLabel51 == null) {
		try {
			ivjLabel51 = new java.awt.Label();
			ivjLabel51.setName("Label51");
			ivjLabel51.setFont(new java.awt.Font("monospaced", 1, 10));
			ivjLabel51.setText("Juegos:");
			ivjLabel51.setBounds(106, 80, 41, 18);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjLabel51;
}
/**
 * Return the Label7 property value.
 * @return java.awt.Label
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private Label getLabel7() {
	if (ivjLabel7 == null) {
		try {
			ivjLabel7 = new java.awt.Label();
			ivjLabel7.setName("Label7");
			ivjLabel7.setFont(new java.awt.Font("monospaced", 1, 10));
			ivjLabel7.setText("Vacas:");
			ivjLabel7.setBounds(167, 33, 37, 18);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjLabel7;
}
/**
 * Return the Label71 property value.
 * @return java.awt.Label
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private Label getLabel71() {
	if (ivjLabel71 == null) {
		try {
			ivjLabel71 = new java.awt.Label();
			ivjLabel71.setName("Label71");
			ivjLabel71.setFont(new java.awt.Font("monospaced", 1, 10));
			ivjLabel71.setText("Vacas:");
			ivjLabel71.setBounds(167, 80, 37, 18);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjLabel71;
}
/**
 * Return the Panel1 property value.
 * @return java.awt.Panel
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private Panel getPanel1() {
	if (ivjPanel1 == null) {
		try {
			ivjPanel1 = new java.awt.Panel();
			ivjPanel1.setName("Panel1");
			ivjPanel1.setLayout(null);
			ivjPanel1.setBackground(java.awt.Color.white);
			ivjPanel1.setBounds(371, 0, 224, 396);
			getPanel1().add(getlChat(), getlChat().getName());
			getPanel1().add(getLabel2(), getLabel2().getName());
			getPanel1().add(gettEnvioChat(), gettEnvioChat().getName());
			getPanel1().add(getbEnvioChat(), getbEnvioChat().getName());
			getPanel1().add(getLabel3(), getLabel3().getName());
			getPanel1().add(getlJugador0(), getlJugador0().getName());
			getPanel1().add(getlJugador2(), getlJugador2().getName());
			getPanel1().add(getLabel4(), getLabel4().getName());
			getPanel1().add(getlPuntosPareja1(), getlPuntosPareja1().getName());
			getPanel1().add(getLabel5(), getLabel5().getName());
			getPanel1().add(getlJuegosPareja1(), getlJuegosPareja1().getName());
			getPanel1().add(getLabel7(), getLabel7().getName());
			getPanel1().add(getlVacasPareja1(), getlVacasPareja1().getName());
			getPanel1().add(getLabel31(), getLabel31().getName());
			getPanel1().add(getlJugador1(), getlJugador1().getName());
			getPanel1().add(getlJugador3(), getlJugador3().getName());
			getPanel1().add(getLabel41(), getLabel41().getName());
			getPanel1().add(getlPuntosPareja2(), getlPuntosPareja2().getName());
			getPanel1().add(getLabel51(), getLabel51().getName());
			getPanel1().add(getlJuegosPareja2(), getlJuegosPareja2().getName());
			getPanel1().add(getLabel71(), getLabel71().getName());
			getPanel1().add(getlVacasPareja2(), getlVacasPareja2().getName());
			getPanel1().add(gettCantidad(), gettCantidad().getName());
			getPanel1().add(getLabel1(), getLabel1().getName());
			getPanel1().add(getbPaso(), getbPaso().getName());
			getPanel1().add(getbVeo(), getbVeo().getName());
			getPanel1().add(getbEnvido(), getbEnvido().getName());
			getPanel1().add(getbOrdago(), getbOrdago().getName());
			getPanel1().add(getbSubo(), getbSubo().getName());
			getPanel1().add(getbAbandonar(), getbAbandonar().getName());
			getPanel1().add(getbMusSI(), getbMusSI().getName());
			getPanel1().add(getbMusNO(), getbMusNO().getName());
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjPanel1;
}
/**
 * Return the bAbandonar property value.
 * @return java.awt.Button
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private Button getbAbandonar() {
	if (ivjbAbandonar == null) {
		try {
			ivjbAbandonar = new java.awt.Button();
			ivjbAbandonar.setName("bAbandonar");
			ivjbAbandonar.setBackground(java.awt.Color.lightGray);
			ivjbAbandonar.setBounds(167, 364, 56, 30);
			ivjbAbandonar.setActionCommand("Abandonar");
			ivjbAbandonar.setLabel("Abandono");
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjbAbandonar;
}
/**
 * Return the bEnvido property value.
 * @return java.awt.Button
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private Button getbEnvido() {
	if (ivjbEnvido == null) {
		try {
			ivjbEnvido = new java.awt.Button();
			ivjbEnvido.setName("bEnvido");
			ivjbEnvido.setBackground(java.awt.Color.lightGray);
			ivjbEnvido.setBounds(112, 335, 56, 30);
			ivjbEnvido.setActionCommand("Envido");
			ivjbEnvido.setLabel("Envido");
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjbEnvido;
}
/**
 * Return the bEnvioChat property value.
 * @return java.awt.Button
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private Button getbEnvioChat() {
	if (ivjbEnvioChat == null) {
		try {
			ivjbEnvioChat = new java.awt.Button();
			ivjbEnvioChat.setName("bEnvioChat");
			ivjbEnvioChat.setBackground(java.awt.Color.lightGray);
			ivjbEnvioChat.setBounds(200, 282, 23, 29);
			ivjbEnvioChat.setActionCommand("EnvioChat");
			ivjbEnvioChat.setLabel("->");
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjbEnvioChat;
}
/**
 * Return the bMusNO property value.
 * @return java.awt.Button
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private Button getbMusNO() {
	if (ivjbMusNO == null) {
		try {
			ivjbMusNO = new java.awt.Button();
			ivjbMusNO.setName("bMusNO");
			ivjbMusNO.setBackground(java.awt.Color.lightGray);
			ivjbMusNO.setBounds(1, 364, 56, 30);
			ivjbMusNO.setActionCommand("MusNO");
			ivjbMusNO.setLabel("Mus NO!");
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjbMusNO;
}
/**
 * Return the bMusSI property value.
 * @return java.awt.Button
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private Button getbMusSI() {
	if (ivjbMusSI == null) {
		try {
			ivjbMusSI = new java.awt.Button();
			ivjbMusSI.setName("bMusSI");
			ivjbMusSI.setBackground(java.awt.Color.lightGray);
			ivjbMusSI.setBounds(1, 335, 56, 30);
			ivjbMusSI.setActionCommand("MusSI");
			ivjbMusSI.setLabel("Mus!");
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjbMusSI;
}
/**
 * Return the bOrdago property value.
 * @return java.awt.Button
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private Button getbOrdago() {
	if (ivjbOrdago == null) {
		try {
			ivjbOrdago = new java.awt.Button();
			ivjbOrdago.setName("bOrdago");
			ivjbOrdago.setBackground(java.awt.Color.lightGray);
			ivjbOrdago.setBounds(112, 364, 56, 30);
			ivjbOrdago.setLabel("Ordago");
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjbOrdago;
}
/**
 * Return the bPaso property value.
 * @return java.awt.Button
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private Button getbPaso() {
	if (ivjbPaso == null) {
		try {
			ivjbPaso = new java.awt.Button();
			ivjbPaso.setName("bPaso");
			ivjbPaso.setBackground(java.awt.Color.lightGray);
			ivjbPaso.setBounds(57, 335, 56, 30);
			ivjbPaso.setActionCommand("Paso");
			ivjbPaso.setLabel("Paso");
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjbPaso;
}
/**
 * Return the bSubo property value.
 * @return java.awt.Button
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private Button getbSubo() {
	if (ivjbSubo == null) {
		try {
			ivjbSubo = new java.awt.Button();
			ivjbSubo.setName("bSubo");
			ivjbSubo.setBackground(java.awt.Color.lightGray);
			ivjbSubo.setBounds(167, 335, 56, 30);
			ivjbSubo.setActionCommand("Subo");
			ivjbSubo.setLabel("Subo");
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjbSubo;
}
/**
 * Return the bVeo property value.
 * @return java.awt.Button
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private Button getbVeo() {
	if (ivjbVeo == null) {
		try {
			ivjbVeo = new java.awt.Button();
			ivjbVeo.setName("bVeo");
			ivjbVeo.setBackground(java.awt.Color.lightGray);
			ivjbVeo.setBounds(57, 364, 56, 30);
			ivjbVeo.setLabel("Veo");
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjbVeo;
}
/**
 * Return the lChat property value.
 * @return java.awt.List
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private List getlChat() {
	if (ivjlChat == null) {
		try {
			ivjlChat = new java.awt.List(14);
			ivjlChat.setName("lChat");
			ivjlChat.setFont(new java.awt.Font("sansserif", 0, 10));
			ivjlChat.setBounds(2, 112, 226, 172);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjlChat;
}
/**
 * Return the lEstadoBaza1 property value.
 * @return java.awt.Label
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private Label getlEstadoBaza() {
	if (ivjlEstadoBaza == null) {
		try {
			ivjlEstadoBaza = new java.awt.Label();
			ivjlEstadoBaza.setName("lEstadoBaza");
			ivjlEstadoBaza.setAlignment(java.awt.Label.CENTER);
			ivjlEstadoBaza.setFont(new java.awt.Font("monospaced", 1, 10));
			ivjlEstadoBaza.setText("Grande: Envidado XX (XX visto)");
			ivjlEstadoBaza.setBounds(92, 97, 194, 21);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjlEstadoBaza;
}
/**
 * Return the lEstadoBaza2 property value.
 * @return java.awt.Label
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private Label getlEstadoBaza2() {
	if (ivjlEstadoBaza2 == null) {
		try {
			ivjlEstadoBaza2 = new java.awt.Label();
			ivjlEstadoBaza2.setName("lEstadoBaza2");
			ivjlEstadoBaza2.setAlignment(java.awt.Label.CENTER);
			ivjlEstadoBaza2.setFont(new java.awt.Font("monospaced", 1, 10));
			ivjlEstadoBaza2.setText("Envidado Por: 1234567890123456");
			ivjlEstadoBaza2.setBounds(92, 112, 194, 21);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjlEstadoBaza2;
}
/**
 * Return the lJuegosPareja1 property value.
 * @return java.awt.Label
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private Label getlJuegosPareja1() {
	if (ivjlJuegosPareja1 == null) {
		try {
			ivjlJuegosPareja1 = new java.awt.Label();
			ivjlJuegosPareja1.setName("lJuegosPareja1");
			ivjlJuegosPareja1.setFont(new java.awt.Font("monospaced", 1, 10));
			ivjlJuegosPareja1.setText("0");
			ivjlJuegosPareja1.setBounds(150, 33, 8, 18);
			ivjlJuegosPareja1.setForeground(java.awt.Color.blue);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjlJuegosPareja1;
}
/**
 * Return the lJuegosPareja2 property value.
 * @return java.awt.Label
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private Label getlJuegosPareja2() {
	if (ivjlJuegosPareja2 == null) {
		try {
			ivjlJuegosPareja2 = new java.awt.Label();
			ivjlJuegosPareja2.setName("lJuegosPareja2");
			ivjlJuegosPareja2.setFont(new java.awt.Font("monospaced", 1, 10));
			ivjlJuegosPareja2.setText("0");
			ivjlJuegosPareja2.setBounds(150, 80, 8, 18);
			ivjlJuegosPareja2.setForeground(java.awt.Color.blue);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjlJuegosPareja2;
}
/**
 * Return the lJugador0 property value.
 * @return java.awt.Label
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private Label getlJugador0() {
	if (ivjlJugador0 == null) {
		try {
			ivjlJugador0 = new java.awt.Label();
			ivjlJugador0.setName("lJugador0");
			ivjlJugador0.setFont(new java.awt.Font("monospaced", 1, 10));
			ivjlJugador0.setText("1234567890123456");
			ivjlJugador0.setBounds(115, 5, 104, 18);
			ivjlJugador0.setForeground(java.awt.Color.blue);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjlJugador0;
}
/**
 * Return the lJugador1 property value.
 * @return java.awt.Label
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private Label getlJugador1() {
	if (ivjlJugador1 == null) {
		try {
			ivjlJugador1 = new java.awt.Label();
			ivjlJugador1.setName("lJugador1");
			ivjlJugador1.setFont(new java.awt.Font("monospaced", 1, 10));
			ivjlJugador1.setText("1234567890123456");
			ivjlJugador1.setBounds(115, 52, 104, 18);
			ivjlJugador1.setForeground(java.awt.Color.blue);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjlJugador1;
}
/**
 * Return the lJugador2 property value.
 * @return java.awt.Label
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private Label getlJugador2() {
	if (ivjlJugador2 == null) {
		try {
			ivjlJugador2 = new java.awt.Label();
			ivjlJugador2.setName("lJugador2");
			ivjlJugador2.setFont(new java.awt.Font("monospaced", 1, 10));
			ivjlJugador2.setText("1234567890123456");
			ivjlJugador2.setBounds(115, 19, 104, 18);
			ivjlJugador2.setForeground(java.awt.Color.blue);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjlJugador2;
}
/**
 * Return the lJugador3 property value.
 * @return java.awt.Label
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private Label getlJugador3() {
	if (ivjlJugador3 == null) {
		try {
			ivjlJugador3 = new java.awt.Label();
			ivjlJugador3.setName("lJugador3");
			ivjlJugador3.setFont(new java.awt.Font("monospaced", 1, 10));
			ivjlJugador3.setText("1234567890123456");
			ivjlJugador3.setBounds(115, 66, 104, 18);
			ivjlJugador3.setForeground(java.awt.Color.blue);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjlJugador3;
}
/**
 * Return the lJugadorAbajo property value.
 * @return java.awt.Label
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private Label getlJugadorAbajo() {
	if (ivjlJugadorAbajo == null) {
		try {
			ivjlJugadorAbajo = new java.awt.Label();
			ivjlJugadorAbajo.setName("lJugadorAbajo");
			ivjlJugadorAbajo.setFont(new java.awt.Font("monospaced", 1, 10));
			ivjlJugadorAbajo.setAlignment(java.awt.Label.CENTER);
			ivjlJugadorAbajo.setText("1234567890123456");
			ivjlJugadorAbajo.setBounds(138, 378, 99, 18);
			ivjlJugadorAbajo.setForeground(java.awt.Color.blue);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjlJugadorAbajo;
}
/**
 * Return the lJugadorArriba property value.
 * @return java.awt.Label
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private Label getlJugadorArriba() {
	if (ivjlJugadorArriba == null) {
		try {
			ivjlJugadorArriba = new java.awt.Label();
			ivjlJugadorArriba.setName("lJugadorArriba");
			ivjlJugadorArriba.setFont(new java.awt.Font("monospaced", 1, 10));
			ivjlJugadorArriba.setText("1234567890123456");
			ivjlJugadorArriba.setAlignment(java.awt.Label.CENTER);
			ivjlJugadorArriba.setBounds(138, 0, 99, 18);
			ivjlJugadorArriba.setForeground(java.awt.Color.blue);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjlJugadorArriba;
}
/**
 * Return the lJugadorDerecha property value.
 * @return java.awt.Label
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private Label getlJugadorDerecha() {
	if (ivjlJugadorDerecha == null) {
		try {
			ivjlJugadorDerecha = new java.awt.Label();
			ivjlJugadorDerecha.setName("lJugadorDerecha");
			ivjlJugadorDerecha.setFont(new java.awt.Font("monospaced", 1, 10));
			ivjlJugadorDerecha.setText("1234567890123456");
			ivjlJugadorDerecha.setAlignment(java.awt.Label.RIGHT);
			ivjlJugadorDerecha.setBounds(272, 189, 99, 18);
			ivjlJugadorDerecha.setForeground(java.awt.Color.blue);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjlJugadorDerecha;
}
/**
 * Return the lJugadorIzquierda property value.
 * @return java.awt.Label
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private Label getlJugadorIzquierda() {
	if (ivjlJugadorIzquierda == null) {
		try {
			ivjlJugadorIzquierda = new java.awt.Label();
			ivjlJugadorIzquierda.setName("lJugadorIzquierda");
			ivjlJugadorIzquierda.setFont(new java.awt.Font("monospaced", 1, 10));
			ivjlJugadorIzquierda.setText("1234567890123456");
			ivjlJugadorIzquierda.setBounds(0, 189, 99, 18);
			ivjlJugadorIzquierda.setForeground(java.awt.Color.blue);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjlJugadorIzquierda;
}
/**
 * Return the lMazo property value.
 * @return java.awt.Label
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private Label getlMazo() {
	if (ivjlMazo == null) {
		try {
			ivjlMazo = new java.awt.Label();
			ivjlMazo.setName("lMazo");
			ivjlMazo.setAlignment(java.awt.Label.CENTER);
			ivjlMazo.setFont(new java.awt.Font("monospaced", 1, 10));
			ivjlMazo.setText("Mazo: 40 cartas");
			ivjlMazo.setBounds(128, 127, 106, 21);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjlMazo;
}
/**
 * Return the lPuntosPareja1 property value.
 * @return java.awt.Label
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private Label getlPuntosPareja1() {
	if (ivjlPuntosPareja1 == null) {
		try {
			ivjlPuntosPareja1 = new java.awt.Label();
			ivjlPuntosPareja1.setName("lPuntosPareja1");
			ivjlPuntosPareja1.setFont(new java.awt.Font("monospaced", 1, 10));
			ivjlPuntosPareja1.setText("00");
			ivjlPuntosPareja1.setBounds(85, 33, 16, 18);
			ivjlPuntosPareja1.setForeground(java.awt.Color.blue);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjlPuntosPareja1;
}
/**
 * Return the lPuntosPareja2 property value.
 * @return java.awt.Label
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private Label getlPuntosPareja2() {
	if (ivjlPuntosPareja2 == null) {
		try {
			ivjlPuntosPareja2 = new java.awt.Label();
			ivjlPuntosPareja2.setName("lPuntosPareja2");
			ivjlPuntosPareja2.setFont(new java.awt.Font("monospaced", 1, 10));
			ivjlPuntosPareja2.setText("00");
			ivjlPuntosPareja2.setBounds(85, 80, 16, 18);
			ivjlPuntosPareja2.setForeground(java.awt.Color.blue);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjlPuntosPareja2;
}
/**
 * Return the Label6 property value.
 * @return java.awt.Label
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private Label getlVacasPareja1() {
	if (ivjlVacasPareja1 == null) {
		try {
			ivjlVacasPareja1 = new java.awt.Label();
			ivjlVacasPareja1.setName("lVacasPareja1");
			ivjlVacasPareja1.setFont(new java.awt.Font("monospaced", 1, 10));
			ivjlVacasPareja1.setText("0");
			ivjlVacasPareja1.setBounds(205, 33, 14, 18);
			ivjlVacasPareja1.setForeground(java.awt.Color.blue);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjlVacasPareja1;
}
/**
 * Return the lVacasPareja2 property value.
 * @return java.awt.Label
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private Label getlVacasPareja2() {
	if (ivjlVacasPareja2 == null) {
		try {
			ivjlVacasPareja2 = new java.awt.Label();
			ivjlVacasPareja2.setName("lVacasPareja2");
			ivjlVacasPareja2.setFont(new java.awt.Font("monospaced", 1, 10));
			ivjlVacasPareja2.setText("0");
			ivjlVacasPareja2.setBounds(205, 80, 14, 18);
			ivjlVacasPareja2.setForeground(java.awt.Color.blue);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjlVacasPareja2;
}
/**
 * Return the TextField1 property value.
 * @return java.awt.TextField
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private TextField gettCantidad() {
	if (ivjtCantidad == null) {
		try {
			ivjtCantidad = new java.awt.TextField();
			ivjtCantidad.setName("tCantidad");
			ivjtCantidad.setText("2");
			ivjtCantidad.setBackground(java.awt.Color.lightGray);
			ivjtCantidad.setBounds(183, 309, 36, 29);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjtCantidad;
}
/**
 * Return the tEnvioChat property value.
 * @return java.awt.TextField
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private TextField gettEnvioChat() {
	if (ivjtEnvioChat == null) {
		try {
			ivjtEnvioChat = new java.awt.TextField();
			ivjtEnvioChat.setName("tEnvioChat");
			ivjtEnvioChat.setBackground(java.awt.Color.lightGray);
			ivjtEnvioChat.setBounds(1, 282, 202, 29);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjtEnvioChat;
}
/**
 * Return the tInforma property value.
 * @return java.awt.TextArea
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private TextArea gettInforma() {
	if (ivjtInforma == null) {
		try {
			ivjtInforma = new java.awt.TextArea("", 0, 0, java.awt.TextArea.SCROLLBARS_NONE);
			ivjtInforma.setName("tInforma");
			ivjtInforma.setText("");
			ivjtInforma.setForeground(java.awt.Color.red);
			ivjtInforma.setFont(new java.awt.Font("sansserif", 1, 10));
			ivjtInforma.setRows(0);
			ivjtInforma.setBounds(80, 255, 211, 45);
			ivjtInforma.setEditable(false);
			ivjtInforma.setCursor(new java.awt.Cursor(java.awt.Cursor.MOVE_CURSOR));
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjtInforma;
}
/**
 * Return the tInformaAntes property value.
 * @return java.awt.TextArea
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private TextArea gettInformaAntes() {
	if (ivjtInformaAntes == null) {
		try {
			ivjtInformaAntes = new java.awt.TextArea("", 0, 0, java.awt.TextArea.SCROLLBARS_NONE);
			ivjtInformaAntes.setName("tInformaAntes");
			ivjtInformaAntes.setText("");
			ivjtInformaAntes.setFont(new java.awt.Font("sansserif", 0, 10));
			ivjtInformaAntes.setRows(0);
			ivjtInformaAntes.setBounds(80, 220, 211, 40);
			ivjtInformaAntes.setEditable(false);
			ivjtInformaAntes.setCursor(new java.awt.Cursor(java.awt.Cursor.MOVE_CURSOR));
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjtInformaAntes;
}
/**
 * Return the tInformaTanteo property value.
 * @return java.awt.TextArea
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private TextArea gettInformaTanteo() {
	if (ivjtInformaTanteo == null) {
		try {
			ivjtInformaTanteo = new java.awt.TextArea("", 0, 0, java.awt.TextArea.SCROLLBARS_NONE);
			ivjtInformaTanteo.setName("tInformaTanteo");
			ivjtInformaTanteo.setBackground(java.awt.Color.cyan);
			ivjtInformaTanteo.setForeground(java.awt.Color.red);
			ivjtInformaTanteo.setFont(new java.awt.Font("sansserif", 1, 10));
			ivjtInformaTanteo.setBounds(109, 142, 163, 75);
			ivjtInformaTanteo.setEditable(false);
			ivjtInformaTanteo.setCursor(new java.awt.Cursor(java.awt.Cursor.MOVE_CURSOR));
			ivjtInformaTanteo.setVisible(false);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjtInformaTanteo;
}
/**
 * Called whenever the part throws an exception.
 * @param exception java.lang.Throwable
 */
private void handleException(Throwable exception) {

	/* Uncomment the following lines to print uncaught exceptions to stdout */
	// System.out.println("--------- UNCAUGHT EXCEPTION ---------");
	// exception.printStackTrace(System.out);
}
/**
 * Handle the Applet init method.
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
public void init() {
	try {
		super.init();
		setName("Jumus");
		setFont(new java.awt.Font("monospaced", 0, 10));
		setLayout(null);
		setBackground(java.awt.Color.lightGray);
		setSize(600, 396);
		add(getPanel1(), getPanel1().getName());
		add(getlJugadorArriba(), getlJugadorArriba().getName());
		add(getlJugadorAbajo(), getlJugadorAbajo().getName());
		add(getlJugadorIzquierda(), getlJugadorIzquierda().getName());
		add(getlJugadorDerecha(), getlJugadorDerecha().getName());
		add(getlEstadoBaza(), getlEstadoBaza().getName());
		add(getlEstadoBaza2(), getlEstadoBaza2().getName());
		add(gettInformaTanteo(), gettInformaTanteo().getName());
		add(gettInformaAntes(), gettInformaAntes().getName());
		add(gettInforma(), gettInforma().getName());
		add(getlMazo(), getlMazo().getName());
		initConnections();
		// user code begin {1}
		misCartas = new int[4] ;
		// user code end
	} catch (java.lang.Throwable ivjExc) {
		// user code begin {2}
		// user code end
		handleException(ivjExc);
	}
}

/**
 * stop - Ejecutado cuando el usuario abandona la pagina
 */
public void stop() {
 try {
  if( canuto != null )
    canuto.close() ;
  if( threadCanuto != null )
    threadCanuto.suspend() ;
 } catch( Exception e ){} ;
 canuto = null ;
 threadCanuto = null ;
}

/**
 * start - Ejecutado cada vez que se recarga la pagina web con el applet
 */
public void start(){
	// INICIALIZAR VARIABLES

	esp16 = "                " ;
	esp86 = esp16 + esp16 + esp16 + esp16 + esp16 + "      " ;
	seleccionDescarte = new int[4] ;
	seleccionDescarte[0] = 0 ;
	seleccionDescarte[1] = 0 ;
	seleccionDescarte[2] = 0 ;
	seleccionDescarte[3] = 0 ;
	ultimoEnvite = "" ;
	textoBaza = "" ;
	nombreJugadores = new String[4] ;
	nombreJugadores[0] = "" ; nombreJugadores[1] = "" ; nombreJugadores[2] = "" ; nombreJugadores[3] = "" ;
	getlJugadorAbajo().setText( getParameter( "Nombre" ) ) ; 
	misCartas[0] = 0 ; misCartas[1] = 0 ; misCartas[2] = 0 ; misCartas[3] = 0 ;
	nombre = getParameter( "Nombre" ) ;
	puerto = getParameter( "Puerto" ) ;
	nombrePartida = getParameter( "NombrePartida" ) ;
	esNueva = getParameter( "EsNueva" ) ;
	numVacas = getParameter( "NumVacas" ) ;
	numJuegos = getParameter( "NumJuegos" ) ;
	numPuntos = getParameter( "NumPuntos" ) ;
	esPrivada = getParameter( "EsPrivada" ) ;
	jugador3 = getParameter( "Jugador3" ) ;
	jugador2 = getParameter( "Jugador2" ) ;
	jugador4 = getParameter( "Jugador4" ) ;
	servidor = getCodeBase().getHost() ;

	getlJugadorArriba().setText( "< desconocido >" ) ; 
	getlJugadorDerecha().setText( "< desconocido >" ) ; 
	getlJugadorIzquierda().setText( "< desconocido >" ) ; 
	getlJugador0().setText( "< desconocido >" ) ; 
	getlJugador1().setText( "< desconocido >" ) ; 
	getlJugador2().setText( "< desconocido >" ) ; 
	getlJugador3().setText( "< desconocido >" ) ;

	for( int i=1 ; i <=9 ; i++ )
	   getlChat().add( " " ) ;
	getlChat().add( "-- Ventana de Chat --" ) ;
	getlChat().add( "BIENVENIDO AL PROGRAMA DE MUS" ) ;
	getlEstadoBaza().setText( "Baza: No empezado" ) ;
	getlEstadoBaza2().setText( "Partida no iniciada" ) ;
	getlMazo().setText( "Mazo: ??" ) ;
	gettInformaAntes().setText( "Bienvenido!" ) ;
	gettInforma().setText( "Esperando inicio de partida con el servidor de mus..." ) ;
	this.repaint() ;
	
	threadCanuto = new Thread( this, "Jumus" ) ;
	threadCanuto.start() ;

}

/**
 * informa( String ) - Pone en el campo Informa un mensaje y en el campo InformaAntes el mensaje
 * que antes estaba en Informa .
 */
public void informa( String msg ) {
 gettInformaAntes().setText( gettInforma().getText() ) ;
 gettInforma().setText( msg ) ;
}

/**
 * enviaMSG - Funcion que envia un mensaje al servidor de partidas de mus.
 */
public void enviaMSG( String msg ) {
 String Envio= (msg+" "+esp86).substring( 0,86 ) ;
 try {
   os.writeBytes( Envio.concat( "\n" ) );
 } catch( Exception e ) { informa( "Error: " + e.getMessage() ) ; } 
}

/**
 * run - Es el hilo de ejecucion que gestiona la comunicacion socket con el servidor de mus
 */
public void run() {

 String respuesta ;

 // Deshabilitar todos los botones
 getbAbandonar().setEnabled( false ) ;
 getbOrdago().setEnabled( false ) ;
 getbVeo().setEnabled( false ) ;
 getbSubo().setEnabled( false ) ;
 getbEnvido().setEnabled( false ) ;
 getbPaso().setEnabled( false ) ;
 getbMusSI().setEnabled( false ) ;
 getbMusNO().setEnabled( false ) ;
 getbEnvioChat().setEnabled( false ) ;
 // CARGAR IMAGENES
 if( gEnvesh == null ) {
  informa( "Cargando imagenes..." ) ;
  gEnvesh = getImage( getDocumentBase(), "envesh.gif" ) ;
  gEnvesv = getImage( getDocumentBase(), "envesv.gif" ) ;
  gMano = getImage( getDocumentBase(), "mano.gif" ) ;
  gOroh = getImage( getDocumentBase(), "oroh.gif" ) ;
  gOrov = getImage( getDocumentBase(), "orov.gif" ) ;
  gCopah = getImage( getDocumentBase(), "copah.gif" ) ;
  gCopav = getImage( getDocumentBase(), "copav.gif" ) ;
  gEspadah = getImage( getDocumentBase(), "espadah.gif" ) ;
  gEspadav = getImage( getDocumentBase(), "espadav.gif" ) ;
  gBastoh = getImage( getDocumentBase(), "bastoh.gif" ) ;
  gBastov = getImage( getDocumentBase(), "bastov.gif" ) ;
  gSotah = getImage( getDocumentBase(), "sotah.gif" ) ;
  gSotav = getImage( getDocumentBase(), "sotav.gif" ) ;
  gCaballoh = getImage( getDocumentBase(), "caballoh.gif" ) ;
  gCaballov = getImage( getDocumentBase(), "caballov.gif" ) ;
  gReyh = getImage( getDocumentBase(), "reyh.gif" ) ;
  gReyv = getImage( getDocumentBase(), "reyv.gif" ) ;
 }

 // CONECTARSE AL SERVIDOR
 if( canuto != null )
  try {
	canuto.close() ;
  } catch( IOException e ){} ;
 try {
  Integer iPuerto = new Integer( puerto ) ;
  canuto = new Socket( servidor, iPuerto.intValue() ) ;
 } catch( IOException e ) {
   informa( "Error conectando al servidor: " + e.getMessage() ) ;
   return ;
  }
 if( canuto != null ) {
   try {
    is = new BufferedReader(new InputStreamReader( canuto.getInputStream()));
    os = new DataOutputStream( canuto.getOutputStream() ) ;
   } catch( Exception e ) {
    informa( "Error: " + e.getMessage() ) ;
    return ;
   }

	 // PREPARAR MENSAJE DE ENTRADA 'N' o 'A'
   if ( esNueva.equalsIgnoreCase( "SI" ) ) { // ENVIAR PARTIDA NUEVA 'N'
    enviaMSG(   "N" +
		(nombrePartida.trim()+esp16).substring(0,16) +
		(numVacas.trim()+"11").substring(0,1) +
		(numJuegos.trim()+"11").substring(0,1) +
		(numPuntos.trim()+"111").substring(0,2) +
		(esPrivada.toUpperCase().equals("SI") ? "1" : "0") +
		(nombre.trim()+esp16).substring(0,16) +
		(jugador3.trim()+esp16).substring(0,16) +
		(jugador2.trim()+esp16).substring(0,16) +
		(jugador4.trim()+esp16).substring(0,16) ) ;
		informa( "Creando partida. Esperando respuesta del servidor" ) ;
   } else { // ENVIAR APUNTARSE 'A'
    enviaMSG( "A"+ (nombrePartida+esp16).substring(0,16) + (nombre+esp16).substring(0,16) ) ;
    informa("Apuntandose a la partida. Esperando respuesta del servidor" ) ;
   }
   // AHORA ESPERO LA RESPUESTA
   respuesta = null ;
   try {
     while( respuesta == null ) respuesta = is.readLine() ;
   } catch (  Exception e ) {
     informa( "Error: "+e.getMessage() ) ;
     return ;
   }
   if( respuesta.charAt( 1 ) == '1' ) {
     informa( "Apuntado a la partida. Esperando resto jugadores!" ) ;
   } else {
     informa( "Error al apuntarse. Respuesta ("+ respuesta.trim() +")" ) ;
     return ;
   }

 getbAbandonar().setEnabled( true ) ;
 getbEnvioChat().setEnabled( true ) ;


   // BUCLE DE LECTURA DE MENSAJES QUE GESTIONA LA PARTIDA 
   while ( true ) {
     respuesta = null ;
     try {
	while( esperoClick == 1 ) Thread.currentThread().sleep(1000) ;
	while ( respuesta == null ) respuesta = is.readLine() ;
     } catch (  Exception e ) {
       informa( "Error: "+e.getMessage() ) ;
       return ;
     }
     switch( respuesta.charAt( 0 )) {
	case 'C' : // PARTIDA COMPLETA
		numJugador = (new Integer( respuesta.substring(5,6) )).intValue() ;
		nombreJugadores[0] = respuesta.substring(6,22).trim() ;
		nombreJugadores[1] = respuesta.substring(22,38).trim() ;
		nombreJugadores[2] = respuesta.substring(38,54).trim() ;
		nombreJugadores[3] = respuesta.substring(54,70).trim() ;
		informa( "Partida a " + respuesta.substring(1,2) +" vacas de "+respuesta.substring(2,3) +
			" juegos de "+ respuesta.substring(3,5) + " puntos." ) ;
		getlJugadorArriba().setText( nombreJugadores[ (numJugador + 2 ) % 4 ] ) ; 
		getlJugadorDerecha().setText(  nombreJugadores[ (numJugador + 1 ) % 4 ] ) ; 
		getlJugadorIzquierda().setText(  nombreJugadores[ (numJugador + 3 ) % 4 ]  ) ; 
		getlJugador0().setText( nombreJugadores[ 0 ] ) ; 
		getlJugador1().setText( nombreJugadores[ 1 ]) ; 
		getlJugador2().setText( nombreJugadores[ 2 ] ) ;
		getlJugador3().setText( nombreJugadores[ 3 ] ) ;
		this.getlMazo().setText( "Mazo: 40 cartas" ) ;
		break ;
	case 'L' : // MENSAJE DE CHAT
		this.getlChat().delItem( 0 ) ;
		this.getlChat().add( nombreJugadores[ (new Integer( respuesta.substring(1,2) )).intValue() ] +
			": " + respuesta.substring(2,66).trim() );
		this.getlChat().setBounds(2, 112, 226, 172);
		break ;
	case 'B' : // PARTIDA CANCELADA
		informa( "Partida cancelada. ("+ respuesta.substring(1,65).trim() + ")" ) ;
		try { canuto.close() ; } catch( Exception e ) {} ;
		return ;
	case 'I' : // REPARTO DE CARTAS
		for( int px = 0 ; px < 4 ; px++ ) {
		  misCartas[px] = (new Integer(respuesta.substring(10+(px*2),12+(px*2)).trim())).intValue() ;
		}
		this.getlMazo().setText( "Mazo: 24 cartas" ) ;
		this.getlEstadoBaza().setText( "Baza: Descarte" ) ;
		this.getlEstadoBaza2().setText( "" ) ;
		this.getlVacasPareja1().setText( respuesta.substring(1,2) ) ;
		this.getlVacasPareja2().setText( respuesta.substring(2,3)  ) ;
		this.getlJuegosPareja1().setText( respuesta.substring(3,4)  ) ;
		this.getlJuegosPareja2().setText( respuesta.substring(4,5)  ) ;
		this.getlPuntosPareja1().setText( respuesta.substring(5,7)  ) ;
		this.getlPuntosPareja2().setText( respuesta.substring(7,9)  ) ;
		mano = (new Integer(respuesta.substring(9,10)).intValue() ) ;
		this.gettInformaTanteo().setText( "" ) ;
		this.gettInformaTanteo().setVisible( false ) ;
		informa( "Cartas recibidas. Esperando accion del jugador mano." ) ;
		this.repaint() ;
		break ;
	case 'Q' : // PREGUNTA SI QUIERE MUS
		informa( "Indique si quiere MUS o NO!" ) ;
		getbMusSI().setEnabled( true ) ;
		getbMusNO().setEnabled( true ) ;
		break ;
	case 'X' : // INFORMA SI ALGUIEN QUISO MUS
		informa( nombreJugadores[(new Integer(respuesta.substring(1,2))).intValue()] + " " +
			((respuesta.charAt(2) == '1') ? "SI":"NO" )+ " quiere MUS." ) ;
		getbMusSI().setEnabled( false ) ;
		getbMusNO().setEnabled( false ) ;
		break ;
	case 'D' : // PREGUNTA DESCARTE
		baza = DESCARTE ;
		informa( "Seleccione cartas a cambiar. Despues haga click en el tapete." ) ;
		break ;
	case 'V' : // INFORMA DESCARTE
		baza = -1 ;
		informa( nombreJugadores[ (new Integer(respuesta.substring(1,2))).intValue()] + " se descarta de " +
			respuesta.substring(2,3) + " cartas." ) ;
		this.getlMazo().setText( "Mazo: " + respuesta.substring( 3,5)+ " cartas" );
		seleccionDescarte[0] = 0 ; seleccionDescarte[1] = 0 ;
		seleccionDescarte[2] = 0 ; seleccionDescarte[3] = 0 ;
		break ;
	case 'W' : // NUEVAS CARTAS TRAS DESCARTE
		for( int px = 0 ; px < 4 ; px++ ) {
		  misCartas[px] = (new Integer(respuesta.substring(1+(px*2),3+(px*2)).trim())).intValue() ;
		}
		this.repaint() ;
		break ;
	case 'J' : // SEAS
		informa( "Recibido seas: " + respuesta.substring( 1,3 )) ;
		break ;
	case 'A' : // ACCION, ENVIDAR, PASAR, SUBIR, VER u ORDAGO
		int habla = (new Integer(respuesta.substring(1,2))).intValue() ;
		String Cab = "";
		if( habla == numJugador ) {
		   if( respuesta.charAt(6) == '1' ) getbOrdago().setEnabled( true ) ;
		   if( respuesta.charAt(4) == '1' ) getbSubo().setEnabled( true ) ;
		   if( respuesta.charAt(3) == '1' ) getbEnvido().setEnabled( true ) ;
		   if( respuesta.charAt(5) == '1' ) getbVeo().setEnabled( true ) ;
		   getbPaso().setEnabled( true ) ;
		   Cab = "Te toca hablar de " ;
		}
		else
		   Cab = "Le toca hablar a "+ nombreJugadores[habla] + " de " ;
		String laBaza = "" ;
		switch( respuesta.charAt(2) ) {
		  case '1' : laBaza = "Grande" ; break ;
		  case '2' : laBaza = "Chica" ; break ;
		  case '3' : laBaza = "Pares" ; break ;
		  case '4' : laBaza = "Juego" ; break ;
		  case '5' : laBaza = "Punto" ; break ;
		}
		Cab = Cab + laBaza +". (Pasar," ;
		if( respuesta.charAt(3) == '1' ) Cab = Cab + "Envidar," ;
		if( respuesta.charAt(4) == '1' ) Cab = Cab + "Subir," ;
		if( respuesta.charAt(5) == '1' ) Cab = Cab + "Ver," ;
		if( respuesta.charAt(6) == '1' ) Cab = Cab + "Ordago" ;
		Cab = Cab + ")" ;
		informa( Cab ) ;
		this.getlEstadoBaza().setText( laBaza + ": Envidado "+ respuesta.substring(7,9) +
			" ("+ respuesta.substring(9,11)+" Visto)" );
		if( textoBaza.equals( laBaza ) || ponQuien == 1 ) {
		  this.getlEstadoBaza2().setText( "Envidado por: " + ultimoEnvite ) ;
		  ponQuien = 0 ;
		}
		else {
		  this.getlEstadoBaza2().setText( "Envidado por: (nadie)" ) ;
		  ultimoEnvite = "" ;
		}
		break ;
	case 'E' : // INFORMA DE ACCION
		if( respuesta.charAt(2) == 'E' || respuesta.charAt(2) == 'S' || respuesta.charAt(2) == 'O' )
		   ultimoEnvite = nombreJugadores[ (new Integer(respuesta.substring(1,2))).intValue()] ;
		ponQuien = 1 ;
		this.getlPuntosPareja1().setText( respuesta.substring(5,7) ) ;
		this.getlPuntosPareja2().setText( respuesta.substring(7,9) ) ;
		String texto = "";
		switch( respuesta.charAt(2) ) {
		  case 'P' : texto = ": Pasa." ; break ;
		  case 'S' : texto = ": Sube " + respuesta.substring(3,5) ; break ;
		  case 'V' : texto = ": Ve la apuesta." ; break ;
		  case 'E' : texto = ": Envida " + respuesta.substring(3,5) ; break ;
		  case 'O' : texto = ": Da Ordago." ; break ;
		}
		informa( nombreJugadores[ (new Integer(respuesta.substring(1,2))).intValue()] + texto ) ;
		getbOrdago().setEnabled( false ) ;
		getbVeo().setEnabled( false ) ;
		getbSubo().setEnabled( false ) ;
		getbEnvido().setEnabled( false ) ;
		getbPaso().setEnabled( false ) ;
		break ;
	case 'P' : // FIN DE RONDA. INFORME SITUACION
		  // SEALAR QUE ESPERO A QUE HAGA CLICK CUANDO SE CANSE DE EXAMINAR LAS CARTAS DE LOS DEMAS
		esperoClick = 1 ;
		informa( "Fin de Ronda. Haga Click en sus cartas para seguir." ) ;
		  // DECIR QUE BAZA HA GANADO CADA UNO
		String t1 = nombreJugadores[0].substring(0,3)+"-"+nombreJugadores[2].substring(0,3)+" ganan: " ;
		String t2 = nombreJugadores[1].substring(0,3)+"-"+nombreJugadores[3].substring(0,3)+" ganan: " ;
		if( respuesta.charAt( 33 ) == '1' ) t1 = t1 + "Grande, " ;
		if( respuesta.charAt( 33 ) == '2' ) t2 = t2 + "Grande, " ;

		if( respuesta.charAt( 36 ) == '1' ) t1 = t1 + "Chica, " ;
		if( respuesta.charAt( 36 ) == '2' ) t2 = t2 + "Chica, " ;

		if( respuesta.charAt( 39 ) == '1' ) t1 = t1 + "Pares, " ;
		if( respuesta.charAt( 39 ) == '2' ) t2 = t2 + "Pares, " ;

		if( respuesta.charAt( 43 ) == '1' ) t1 = t1 + "Juego/Punto, " ;
		if( respuesta.charAt( 43 ) == '2' ) t1 = t1 + "Juego/Punto, " ;

		if( respuesta.charAt( 47 ) == '1' ) t1 = t1 + "!Juego, " ;
		if( respuesta.charAt( 47 ) == '2' ) t1 = t1 + "!Juego, " ;

		if( respuesta.charAt( 48 ) == '1' ) t1 = t1 + "!Vaca" ;
		if( respuesta.charAt( 48 ) == '2' ) t1 = t1 + "!Vaca" ;
		oldRespuesta = new String( respuesta ) ;
		this.repaint() ;
		this.gettInformaTanteo().setVisible( true ) ;
		this.gettInformaTanteo().setText( t1 + " // " + t2 ) ;

		break ;

	case 'K' : // FIN DE PARTIDA
		String Ganadores ;
		if( respuesta. charAt( 1 ) == '1' )
		  Ganadores = nombreJugadores[0] + " - " + nombreJugadores[2] ;
		else
		  Ganadores = nombreJugadores[1] + " - " + nombreJugadores[3] ;
		informa( "Partida Finalizada!. Ganadores: " + Ganadores ) ;
		try { canuto.close() ; } catch( Exception e ) {} ;
		return ;
     }

   }
 }
}
/**
 * Initializes connections
 * @exception java.lang.Exception The exception description.
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void initConnections() throws Exception {
	// user code begin {1}
	// user code end
	getbAbandonar().addActionListener(ivjEventHandler);
	getbOrdago().addActionListener(ivjEventHandler);
	getbVeo().addActionListener(ivjEventHandler);
	getbSubo().addActionListener(ivjEventHandler);
	getbEnvido().addActionListener(ivjEventHandler);
	getbPaso().addActionListener(ivjEventHandler);
	getbEnvioChat().addActionListener(ivjEventHandler);
	this.addMouseListener(ivjEventHandler);
	getbMusSI().addActionListener(ivjEventHandler);
	getbMusNO().addActionListener(ivjEventHandler);
}

/**
 * main entrypoint - starts the part when it is run as an application
 * @param args java.lang.String[]
 */
public static void main(java.lang.String[] args) {
	try {
		Frame frame = new java.awt.Frame();
		Jumus aJumus;
		Class iiCls = Class.forName("Jumus");
		ClassLoader iiClsLoader = iiCls.getClassLoader();
		aJumus = (Jumus)java.beans.Beans.instantiate(iiClsLoader,"Jumus");
		frame.add("Center", aJumus);
		frame.setSize(aJumus.getSize());
		frame.addWindowListener(new java.awt.event.WindowAdapter() {
			public void windowClosing(java.awt.event.WindowEvent e) {
				System.exit(0);
			};
		});
		frame.setVisible(true);
	} catch (Throwable exception) {
		System.err.println("Exception occurred in main() of java.applet.Applet");
		exception.printStackTrace(System.out);
	}
}

/**
 * Metodo pintaCarta() que pinta la carta indicada donde se le diga
 */
public void pintaCarta( Graphics g , int donde, int quien, int carta ) {

 int situacion = ( 4 + quien - numJugador ) % 4 ;
 int palo = ((carta % 40) - 1) / 10 ;
 int figura = carta % 10 ;
 int iniX, iniY ;
 Image imagenPalo = null ;

 if( situacion == 0 || situacion == 2 ) { // PINTAR EN VERTICAL
  iniX = coorX[ donde ] + 1 ;
  iniY = 1 + ( situacion == 0 ? 301 : 20 ) ;
  g.setColor( Color.white ) ;
  g.fillRect( iniX -1, iniY -1 , 46,75 ) ;
  g.setColor( Color.black ) ;
  if( carta != 0 ) g.drawRect( iniX -1, iniY -1 , 46,75 ) ;
  switch( palo ) {
   case 0 : imagenPalo = gOrov ; break ;
   case 1 : imagenPalo = gCopav ; break ;
   case 2 : imagenPalo = gEspadav ; break ;
   case 3 : imagenPalo = gBastov ; break ;
  }
  switch( figura ) {
   case 1 :
		g.drawImage( imagenPalo, iniX + 15 ,iniY + 24, this ) ;
		break ;
   case 2 :
		g.drawImage( imagenPalo, iniX+3 ,iniY + 24, this ) ;
		g.drawImage( imagenPalo, iniX + 27 ,iniY + 24, this ) ;
		break ;
   case 3 :
		g.drawImage( imagenPalo, iniX +3 ,iniY +3 , this ) ;
		g.drawImage( imagenPalo, iniX + 27 ,iniY + 3, this ) ;
		g.drawImage( imagenPalo, iniX + 15 ,iniY + 45, this ) ;
		break ;
   case 4 :
		g.drawImage( imagenPalo, iniX +3, iniY + 3, this ) ;
		g.drawImage( imagenPalo, iniX + 27 ,iniY + 3,  this ) ;
		g.drawImage( imagenPalo, iniX +3 ,iniY + 45, this ) ;
		g.drawImage( imagenPalo, iniX + 27 ,iniY + 45, this ) ;
		break ;
   case 5 :
		g.drawImage( imagenPalo, iniX +3, iniY + 3, this ) ;
		g.drawImage( imagenPalo, iniX + 27 ,iniY + 3,  this ) ;
		g.drawImage( imagenPalo, iniX +3 ,iniY + 45, this ) ;
		g.drawImage( imagenPalo, iniX + 27 ,iniY + 45, this ) ;
		g.drawImage( imagenPalo, iniX + 15 ,iniY + 24, this ) ;
		break ;
   case 6 :
		g.drawImage( imagenPalo, iniX ,iniY , this ) ;
		g.drawImage( imagenPalo, iniX + 15 ,iniY , this ) ;
		g.drawImage( imagenPalo, iniX + 30 ,iniY , this ) ;
		g.drawImage( imagenPalo, iniX ,iniY + 48, this ) ;
		g.drawImage( imagenPalo, iniX + 15,iniY + 48, this ) ;
		g.drawImage( imagenPalo, iniX + 30,iniY + 48, this ) ;
		break ;
   case 7 :
		g.drawImage( imagenPalo, iniX ,iniY , this ) ;
		g.drawImage( imagenPalo, iniX + 15 ,iniY , this ) ;
		g.drawImage( imagenPalo, iniX + 30 ,iniY , this ) ;
		g.drawImage( imagenPalo, iniX ,iniY + 48, this ) ;
		g.drawImage( imagenPalo, iniX + 15,iniY + 48, this ) ;
		g.drawImage( imagenPalo, iniX + 30,iniY + 48, this ) ;
		g.drawImage( imagenPalo, iniX + 15,iniY + 24, this ) ;
		break ;
   case 8 :
		g.drawImage( imagenPalo, iniX ,iniY , this ) ;
		g.drawImage( gSotav, iniX+15, iniY + 24 , this ) ;
		break ;
   case 9 :
		g.drawImage( imagenPalo, iniX ,iniY , this ) ;
		g.drawImage( gCaballov, iniX+15, iniY + 24 , this ) ;
		break ;
   case 0 :
		if ( carta == 0 )
		  g.drawImage( gEnvesv, iniX -1 , iniY, this ) ;
		else {
		  g.drawImage( imagenPalo, iniX ,iniY , this ) ;
		  g.drawImage( gReyv, iniX+15, iniY + 24 , this ) ;
		}
		break ;
  }
  // SI ESTOY EN DESCARTE Y HA SIDO SELECCIONADA. PINTARLA CRUZADA
   if( quien == numJugador && seleccionDescarte[donde] != 0 ) {
	g.setColor( Color.red ) ;
	g.drawLine( iniX, iniY, iniX + 46, iniY + 75 ) ;
	g.drawLine( iniX + 46 , iniY, iniX, iniY + 75 ) ;
   }
 } else { // PINTAR EN HORIZONTAL
  iniY = coorY[ donde ] + 1 ;
  iniX = 1 + ( situacion == 1 ? 294 : 0 ) ;
  g.setColor( Color.white ) ;
  g.fillRect( iniX -1, iniY -1, 75, 46 ) ;
  g.setColor( Color.black ) ;
  if( carta != 0 ) g.drawRect( iniX -1, iniY -1, 75, 46 ) ;
  switch( palo ) {
   case 0 : imagenPalo = gOroh ; break ;
   case 1 : imagenPalo = gCopah ; break ;
   case 2 : imagenPalo = gEspadah ; break ;
   case 3 : imagenPalo = gBastoh ; break ;
  }
  switch( figura ) {
   case 1 :
		g.drawImage( imagenPalo, iniX + 24 ,iniY + 15, this ) ;
		break ;
   case 2 :
		g.drawImage( imagenPalo, iniX + 24, iniY + 3, this ) ;
		g.drawImage( imagenPalo, iniX + 24, iniY + 27, this ) ;
		break ;
   case 3 :
		g.drawImage( imagenPalo, iniX +3 ,iniY + 3, this ) ;
		g.drawImage( imagenPalo, iniX +3 ,iniY + 27, this ) ;
		g.drawImage( imagenPalo, iniX + 45 ,iniY + 15, this ) ;
		break ;
   case 4 :
		g.drawImage( imagenPalo, iniX + 3, iniY + 3 , this ) ;
		g.drawImage( imagenPalo, iniX +3 ,iniY + 27,  this ) ;
		g.drawImage( imagenPalo, iniX + 45 ,iniY + 3, this ) ;
		g.drawImage( imagenPalo, iniX + 45 ,iniY + 27, this ) ;
		break ;
   case 5 :
		g.drawImage( imagenPalo, iniX + 3, iniY + 3 , this ) ;
		g.drawImage( imagenPalo, iniX +3 ,iniY + 27,  this ) ;
		g.drawImage( imagenPalo, iniX + 45 ,iniY + 3, this ) ;
		g.drawImage( imagenPalo, iniX + 45 ,iniY + 27, this ) ;
		g.drawImage( imagenPalo, iniX + 24 ,iniY + 15, this ) ;
		break ;
   case 6 :
		g.drawImage( imagenPalo, iniX ,iniY , this ) ;
		g.drawImage( imagenPalo, iniX ,iniY + 15, this ) ;
		g.drawImage( imagenPalo, iniX ,iniY + 30 , this ) ;
		g.drawImage( imagenPalo, iniX + 48 ,iniY , this ) ;
		g.drawImage( imagenPalo, iniX + 48,iniY + 15, this ) ;
		g.drawImage( imagenPalo, iniX + 48,iniY + 30, this ) ;
		break ;
   case 7 :
		g.drawImage( imagenPalo, iniX ,iniY , this ) ;
		g.drawImage( imagenPalo, iniX ,iniY + 15, this ) ;
		g.drawImage( imagenPalo, iniX ,iniY + 30 , this ) ;
		g.drawImage( imagenPalo, iniX + 48 ,iniY, this ) ;
		g.drawImage( imagenPalo, iniX + 48,iniY + 15, this ) ;
		g.drawImage( imagenPalo, iniX + 48,iniY + 30, this ) ;
		g.drawImage( imagenPalo, iniX + 24,iniY + 15, this ) ;
		break ;
   case 8 :
		g.drawImage( imagenPalo, iniX ,iniY + 30, this ) ;
		g.drawImage( gSotah, iniX+24, iniY , this ) ;
		break ;
   case 9 :
		g.drawImage( imagenPalo, iniX ,iniY + 30, this ) ;
		g.drawImage( gCaballoh, iniX+24, iniY , this ) ;
		break ;
   case 0 :
		if ( carta == 0 )
		  g.drawImage( gEnvesh, iniX , iniY -1, this ) ;
		else {
		  g.drawImage( imagenPalo, iniX ,iniY + 30 , this ) ;
		  g.drawImage( gReyh, iniX+24, iniY , this ) ;
		}
		break ;
  }
 }
 this.validate() ;
}

/**
 * Metodo Paint() que se llama al redibujar la pantalla
 */
public void paint( Graphics g ){

	//   PINTO MIS CARTAS Y EL ENVES DE LAS DE LOS DEMAS
  for (int x = 0 ; x < 4 ; x++) {
   pintaCarta( g, x, numJugador, misCartas[x] ) ;
   if( esperoClick != 1 ) {
    pintaCarta( g, x, (numJugador + 1) % 4, 0 ) ;
    pintaCarta( g, x, (numJugador + 2) % 4, 0 ) ;
    pintaCarta( g, x, (numJugador + 3) % 4, 0 ) ;
   }
  }
  // PINTAR LAS CARTAS DE LOS DEMAS Y MUESTRA TANTEO SI PROCEDE
 if( esperoClick == 1 ) {
  gettInformaTanteo().setVisible( true ) ;
  for( int jugador = 0 ; jugador < 4 ; jugador++ )
   for( int sucarta = 0 ; sucarta < 4 ; sucarta++ )
    try {
	pintaCarta( g, sucarta, jugador, (new Integer(oldRespuesta.substring(1+(sucarta*2)+(jugador*8),3+(sucarta*2)+(jugador*8)).trim())).intValue() ) ;
    } catch( Exception e ) {} ;
  } else {
   gettInformaTanteo().setVisible( false ) ;
  }

	// PINTO LOS CUADROS VACIOS DEL MANO Y LA MANO DONDE CORRESPONDA
  g.setColor( Color.lightGray ) ;
  g.fillRect( 278, 357, 20, 20 ) ;
  g.fillRect( 350,  71, 20, 20 ) ;
  g.fillRect( 71,   20, 20, 20 ) ;
  g.fillRect( 0,   302, 20, 20 ) ; 
	// PINTO LA MANO A QUIEN CORRESPONDA
  if( mano > -1 ) {
   int x = 0, y = 0;
   switch( (4 + mano - numJugador) % 4) {
    case 0 : x = 278; y = 357; break ;
    case 1 : x = 350; y = 71 ; break ;
    case 2 : x = 71 ; y = 20 ; break ;
    case 3 : x = 0  ; y = 302; break ;
   } ;
   g.drawImage( gMano, x, y, this ) ; 
  }
}

/**
 * Insert the method's description here.
 * Creation date: (05/15/00 13:37:53)
 */
public void musNO() {
	enviaMSG( "T0" ) ;
	}
/**
 * Insert the method's description here.
 * Creation date: (05/15/00 13:37:06)
 */
public void musSI() {
	enviaMSG( "T1" ) ;
	}
/**
 * Insert the method's description here.
 * Creation date: (05/15/00 03:22:09)
 */
public void ordago() {
	enviaMSG( "HO  " ) ;
	}
/**
 * Insert the method's description here.
 * Creation date: (05/15/00 03:27:26)
 */
public void paso() {
		enviaMSG( "HP  " ) ;
	}
/**
 * Insert the method's description here.
 * Creation date: (05/15/00 03:25:32)
 */
public void subo() {
	enviaMSG( "HS"+this.gettCantidad().getText() ) ;
	}
/**
 * Insert the method's description here.
 * Creation date: (05/15/00 03:24:11)
 */
public void veo() {
	enviaMSG( "HV  " ) ;
	}
/**
 * Insert the method's description here.
 * Creation date: (05/15/00 03:26:32)
 */
public void envido() {
	enviaMSG( "HE"+this.gettCantidad().getText() ) ;
	}
/**
 * Insert the method's description here.
 * Creation date: (05/15/00 03:28:36)
 */
public void envioChat() {
	enviaMSG( "M"+this.gettEnvioChat().getText() ) ;
	}
/**
 * Insert the method's description here.
 * Creation date: (05/15/00 03:20:55)
 */
public void abandono() {
	enviaMSG( "F" ) ;
	}

/**
 * Controlo si ha pinchado en una carta durante el descarte para indicar
 * que se deshace de ella.
 */
public void jumus_MouseClicked(java.awt.event.MouseEvent mouseEvent) {
 
 if( esperoClick == 1 && mouseEvent.getY() > 300 && 
	mouseEvent.getX() > coorX[0] && mouseEvent.getX() < coorX[3]+46 ) {
   esperoClick = 0 ;
   this.gettInformaTanteo().setVisible( false ) ;
   this.gettInformaTanteo().setText( "" ) ;
   this.repaint() ;
 }

 int actualiza = 0 ;
 // SI ESTAMOS EN DESCARTE, PINCHA EN UNA CARTA SUYA,CAMBIA ESTADO DE LA CARTA Y REPINTA
 if( baza == DESCARTE ) {
  if( mouseEvent.getY() > 300 )
   for( int x = 0 ; x < 4 ; x++ )
    if( mouseEvent.getX() > coorX[x] && mouseEvent.getX() < coorX[x] + 47 ) {
	 if( seleccionDescarte[x] == 0 )
	  seleccionDescarte[x] = 1 ;
	 else
	  seleccionDescarte[x] = 0 ;
	 this.repaint() ;
	 actualiza = 1 ;
    }
	// PINCHO FUERA Y SI HE SELECCIONADO CARTAS; LAS ENVIO
  int cuantas = seleccionDescarte[0] + seleccionDescarte[1] + seleccionDescarte[2] + seleccionDescarte[3] ;
  if( actualiza == 0 && cuantas > 0) {
    String c = "U" + String.valueOf(cuantas).trim() ;
    for( int x = 0 ; x < 4 ; x++ )
     if( seleccionDescarte[x] == 1 ) {
	String c2 =  "  " + (String.valueOf( misCartas[x] ).trim()) ;
	c = c + c2.substring( c2.length()-2, c2.length() ) ;
     }
    enviaMSG( c ) ;
  }
 }
}

}
